<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 7/19/18
 * Time: 5:41 PM
 */

namespace Orbipay\PaymentsApi\Client\Constant;

class HttpParamConstants
{

    //Header Params
    const CLIENT_KEY = 'client_key';
    const AUTHORIZATION_HEADER = 'Authorization';
    const USER_AGENT = 'User-Agent';
    const PRODUCT = 'product';
    const CHANNEL = 'channel';
    const REQUESTOR = 'requestor';
    const REQUESTOR_TYPE = 'requestor_type';
    const TIMESTAMP = 'timestamp';
    const IDEMPOTENT_REQUEST_KEY = 'idempotent_request_key';
    const HEADER_CONTENT_TYPE = 'Content-Type';
    const X_OPAY_HEADERS = 'X-OPAY-Headers';
    const ACCEPT = 'accept';
    const RESPONSE_CODES = 'response_codes';
    const RESPONSE_TEXT = 'response_text';
    const REQUEST_UUID = 'request_uuid';
    const ATTRIBUTES = 'attributes';
    const ATTRIBUTE = 'attribute';

    const API_END_POINT = 'api_end_point';

    // Added for new JSON REST Connect API
    const CUSTOMER_REFERENCE = 'customer_reference';
    const FIRST_NAME = 'first_name';
    const LAST_NAME = 'last_name';
    const MIDDLE_NAME = 'middle_name';
    const GENDER = 'gender';
    const SSN = 'ssn';
    const LANGUAGE = 'language';
    const EMAIL = 'email';
    const ADDRESS_LINE1 = 'address_line1';
    const ADDRESS_LINE2 = 'address_line2';
    const ADDRESS_CITY = 'address_city';
    const ADDRESS_STATE = 'address_state';
    const ADDRESS_COUNTRY = 'address_country';
    const ADDRESS_ZIP1 = 'address_zip1';
    const ADDRESS_ZIP2 = 'address_zip2';
    const ACCOUNT_TYPE = 'account_type';
    const YES = 'yes';
    const NO = 'no';
    const DATE_OF_BIRTH = 'date_of_birth';
    const HOME_PHONE = 'home_phone';
    const WORK_PHONE = 'work_phone';
    const MOBILE_PHONE = 'mobile_phone';
    const CUSTOMER_ACCOUNTS = 'customer_accounts';
    const FUNDING_ACCOUNTS = 'funding_accounts';
    const PAYMENTS = 'payments';
    const CUSTOMER = 'customer';
    const ADDRESS = 'address';
    const COMMENTS = 'comments';
    const ID = 'id';
    const STATUS = 'status';
    const URL = 'url';

    //path params
    const PATH_PARAM_ID_CUSTOMER = 'ID_CUSTOMER';
    const PATH_PARAM_ID_FUNDING_ACCOUNT = 'ID_FUNDING_ACCOUNT';
    const PATH_PARAM_ID_PAYMENT = 'ID_PAYMENT';
    const PATH_PARAM_ID_CUSTOMER_ACCOUNT = 'ID_CUSTOMER_ACCOUNT';
    const PATH_PARAM_ID_PAYMENT_SETUP = 'ID_PAYMENT_SETUP';
    const PATH_PARAM_ID_FEE = 'ID_FEE';
    const PATH_PARAM_ID_REFUND = 'ID_REFUND';

    const CARD_CVV_NUMBER = 'card_cvv_number';
    const DELETED = 'deleted';
    const PAYMENT_SETUP_SCHEDULE_TYPE = 'payment_setup_schedule_type';
    const PAYMENT_RECURRING_TYPE = 'payment_recurring_type';
    const PAYMENT_RECURRING_COUNT = 'payment_recurring_count';
    const PAYMENT_AMOUNT_TYPE = 'payment_amount_type';
    const PAYMENT_START_DATE = 'payment_start_date';
    const PAYMENT_END_DATE = 'payment_end_date';
    const PAYMENT_LIMIT_AMOUNT = 'payment_limit_amount';
    const PAYMENT_SCHEDULE = 'payment_schedule';
    const RETRIEVE_LIST = 'list';
    const TOTAL_RESULTS_COUNT = 'total_results_count';
    const HAS_MORE_RESULTS = 'has_more_results';
    const FROM_INDEX = 'from_index';
    const TO_INDEX = 'to_index';
    const ACH_ELIGIBLE_FLAG = 'ach_eligible_flag';
    const ACCOUNT_HOLDER_NAME = 'account_holder_name';
    const NICKNAME = 'nickname';
    const ACCOUNT_NUMBER = 'account_number';
    const ISSUER_NAME = 'issuer_name';
    const ABA_ROUTING_NUMBER = 'aba_routing_number';
    const ACCOUNT_SUBTYPE = 'account_subtype';
    const CURRENCY_CODE_3D = 'currency_code3d';
    const EXPIRY_DATE = 'expiry_date';
    const ACCOUNT_HOLDER_TYPE = 'account_holder_type';
    const ACCOUNT_HOLDER_TYPE_PERSONAL = 'PERSONAL';
    const CUSTOM_FIELDS = 'custom_fields';
    const PAYMENT_REFERENCE = 'payment_reference';
    const AMOUNT = 'amount';
    const REFUND_AMOUNT = 'refund_amount';
    const PAYMENT_DATE = 'payment_date';
    const FEE = 'fee';
    const FEE_AMOUNT = 'fee_amount';
    const FEE_TYPE = 'fee_type';
    const FUNDING_ACCOUNT = 'funding_account';
    const CUSTOMER_ACCOUNT = 'customer_account';
    const CONFIRMATION_NUMBER = 'confirmation_number';
    const PAYMENT_ENTRY_DATE = 'payment_entry_date';
    const PAYMENT_RETURN_DATE = 'payment_return_date';
    const RETURN_CODE = 'return_code';
    const CURRENT_BALANCE = 'current_balance';
    const CURRENT_STATEMENT_BALANCE = 'current_statement_balance';
    const MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAST_AMOUNT_DUE = 'past_amount_due';
    const PAYMENT_DUE_DATE = 'payment_due_date';
    const ATM_ELIGIBLE_FLAG = 'atm_eligible_flag';
    const PAYMENT_METHOD = 'payment_method';
    const PAYMENT_SCHEDULE_TYPE = 'payment_schedule_type';
    const PAYMENT_PLAN_ID = 'payment_plan_id';
    const PAYMENT_DEFER_DAYS = 'payment_defer_days';
    const _TXN_PYMNT_SCHLD_TYPE = '_txn_pymnt_schld_type';

    const RECURRING_PAYMENT_AMOUNT_TYPE = 'recurring_payment_amount_type';
    const STATEMENT_DATE = 'statement_date';
    const PAYMENT_REQUEST_DATE = 'payment_request_date';

    const PAGE_SIZE = 'page_size';
    const QUERY_ID = 'query_id';
    const FROM_DATE = 'from_date';
    const TO_DATE = 'to_date';
    const VARIABLE_RECURRING_ENROLMENT = 'variable_recurring_enrolment';
    const AUTOPAY_ENROLLMENT = 'autopay_enrollment';

    // Customer Accounts info
    const CUSTOMER_ACCOUNT_REFERENCE = 'customer_account_reference';
    // Funding sources info
    const CURRENCY_CODE3D = 'currency_code3d';
    const CARD_EXPIRY_DATE = 'expiry_date';
    const LOCALE = 'locale';
    // Payment info
    const PAYMENT = 'payment';
    const PAYMENT_SETUP = 'payment_setup';
    const PAYER_ID = 'CustomerSnapshotResponse[id]';
    const TRANSACTION_TYPE = 'transaction_type';
    const PAYMENT_SETUP_REFERENCE = 'payment_setup_reference';

    // Refund info
    const REFUND = 'refund';
    const REFUND_REFERENCE = 'refund_reference';
    const REFUND_TYPE = 'refund_type';


    // Query Paramertes names
    const QUERY_PARAM_ID_CUSTOMER = 'id_customer';
    const QUERY_PARAM_ID_FUNDING_ACCOUNT = 'id_funding_account';
    const QUERY_PARAM_ID_CUSTOMER_ACCOUNT = 'id_customer_account';

    const TRUE = 'true';
    const FALSE = 'false';

    //symbols
    const DOT = '.';
    const LEFT_SQUARE_BRACE = '[';
    const RIGHT_SQUARE_BRACE = ']';
}