<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 7/20/18
 * Time: 2:34 PM
 */

namespace Orbipay\PaymentsApi\Client\Model\Base;

class Address implements \JsonSerializable
{
    /**
     * @var string
     */
    public $address_line1;

    /**
     * @var string
     */
    private $address_line2;

    /**
     * @var string
     */
    private $address_city;

    /**
     * @var string
     */
    private $address_state;

    /**
     * @var string
     */
    private $address_country;

    /**
     * @var string
     */
    private $address_zip1;

    /**
     * @var string
     */
    private $address_zip2;

    /**
     * AddressVO constructor.
     * @param string $address_line1
     * @param string $address_line2
     * @param string $address_city
     * @param string $address_state
     * @param string $address_country
     * @param string $address_zip1
     * @param string $address_zip2
     */
    public function __construct($address_line1 = null, $address_line2 = null, $address_city = null, $address_state = null, $address_country = null, $address_zip1 = null, $address_zip2 = null)
    {
        $this->address_line1 = $address_line1;
        $this->address_line2 = $address_line2;
        $this->address_city = $address_city;
        $this->address_state = $address_state;
        $this->address_country = $address_country;
        $this->address_zip1 = $address_zip1;
        $this->address_zip2 = $address_zip2;
    }

    /**
     * @return string
     */
    public function getAddressLine1()
    {
        return $this->address_line1;
    }

    /**
     * @return string
     */
    public function getAddressLine2()
    {
        return $this->address_line2;
    }

    /**
     * @return string
     */
    public function getAddressCity()
    {
        return $this->address_city;
    }

    /**
     * @return string
     */
    public function getAddressState()
    {
        return $this->address_state;
    }

    /**
     * @return string
     */
    public function getAddressCountry()
    {
        return $this->address_country;
    }

    /**
     * @return string
     */
    public function getAddressZip1()
    {
        return $this->address_zip1;
    }

    /**
     * @return string
     */
    public function getAddressZip2()
    {
        return $this->address_zip2;
    }


    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return get_object_vars($this);
    }
}