<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 7/19/18
 * Time: 11:25 AM
 */

namespace Orbipay\PaymentsApi\Client\Model\Base;

use Orbipay\PaymentsApi\Client\Util\CommonUtil;

class Attributes implements \JsonSerializable
{
    /**
     * @var Attribute[]
     */
    private $list = array();

    /**
     * @return Attribute[]
     */
    public function getList()
    {
        return $this->list;
    }


    /**
     * @param string $key
     * @param string $value
     */
    public function add($key = null, $value = null)
    {
        $attribute = new Attribute($key, $value);
        $this->list[] = $attribute;
    }


    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this));
    }

}