<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 8/28/18
 * Time: 2:26 PM
 */

namespace Orbipay\PaymentsApi\Client\Model\Base;


class ResponseCode implements \JsonSerializable
{
    /**
     * @var string
     */
    private $code;

    /**
     * @var string
     */
    private $text;

    /**
     * ResponseCode constructor.
     * @param string $code
     * @param string $text
     */
    public function __construct($code = null, $text = null)
    {
        $this->code = $code;
        $this->text = $text;
    }

    /**
     * @return string
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * @param string $code
     */
    public function setCode($code = null)
    {
        $this->code = $code;
    }

    /**
     * @return string
     */
    public function getText()
    {
        return $this->text;
    }

    /**
     * @param string $text
     */
    public function setText($text = null)
    {
        $this->text = $text;
    }

    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return get_object_vars($this);
    }
}