<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 7/24/18
 * Time: 3:37 PM
 */

namespace Orbipay\PaymentsApi\Client\Model\Error;

use Orbipay\PaymentsApi\Client\Constant\RestConstants;

class Error implements \JsonSerializable
{

    /**
     * @var string
     */
    private $code;
    /**
     * @var string
     */
    private $message;
    /**
     * @var string
     */
    private $field;

    /**
     * ErrorVO constructor.
     * @param string $code
     * @param string $message
     * @param string $field
     */
    public function __construct($code = null, $message = null, $field = null)
    {
        $this->code = $code;
        $this->message = $message;
        $this->field = $field;
    }

    /**
     * @return string
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * @param string $code
     */
    public function setCode($code = null)
    {
        $this->code = $code;
    }

    /**
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * @param string $message
     */
    public function setMessage($message = null)
    {
        $this->message = $message;
    }

    /**
     * @return string
     */
    public function getField()
    {
        return $this->field;
    }

    /**
     * @param string $field
     */
    public function setField($field = null)
    {
        $this->field = $field;
    }

    public static function getTechDifficultiesError()
    {
        $error = new Error();
        $error->setCode(RestConstants::ERROR_TECH_DIFFICULTIES_CODE);
        $error->setMessage(RestConstants::ERROR_TECH_DIFFICULTIES_MESSAGE);
        return $error;
    }

    public static function getFieldError($field)
    {
        $error = new Error();
        $error->setCode(RestConstants::ERROR_FIELD_CODE);
        $error->setMessage(RestConstants::ERROR_FIELD_MESSAGE);
        $error->setField($field);

        return $error;
    }

    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return get_object_vars($this);
    }
}