<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 8/21/18
 * Time: 5:14 PM
 */

namespace Orbipay\PaymentsApi\Client\Model\Payment;


use Orbipay\PaymentsApi\Client\Enum\FeeType;
use Orbipay\PaymentsApi\Client\Util\CommonUtil;
use JsonSerializable;

class Fee implements JsonSerializable
{
    /**
     * @var string
     */
    private $id;

    /**
     * @var string
     */
    private $url;

    /**
     * @var string
     */
    private $fee_amount;

    /**
     * @var FeeType
     */
    private $fee_type;

    /**
     * FeePayment constructor.
     * @param string $fee_amount
     */
    public function __construct($fee_amount = null)
    {
        $this->fee_amount = $fee_amount;
    }

    /**
     * @internal
     * @param string $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @internal
     * @param string $url
     */
    public function setUrl($url)
    {
        $this->url = $url;
    }

    /**
     * @internal
     * @param FeeType $fee_type
     */
    public function setFeeType($fee_type)
    {
        $this->fee_type = $fee_type;
    }

    /**
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * @return string
     */
    public function getFeeAmount()
    {
        return $this->fee_amount;
    }

    /**
     * @return FeeType
     */
    public function getFeeType()
    {
        return $this->fee_type;
    }

    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this));
    }
}