<?php
/**
 * Created by PhpStorm.
 * User: Alacriti Inc.
 * Date: 8/21/18
 * Time: 5:14 PM
 */

namespace Orbipay\PaymentsApi\Client\Model\Refund;


use Orbipay\PaymentsApi\Client\Enum\FeeType;
use Orbipay\PaymentsApi\Client\Util\CommonUtil;

class FeeRefund implements \JsonSerializable
{
    /**
     * @var string
     */
    private $fee_refund_amount;

    /**
     * @var FeeType
     */
    private $fee_type;

    /**
     * FeePayment constructor.
     * @param string $fee_refund_amount
     */
    public function __construct($fee_refund_amount = null)
    {
        $this->fee_refund_amount = $fee_refund_amount;
    }

    /**
     * @internal
     * @param FeeType $fee_type
     */
    public function setFeeType($fee_type)
    {
        $this->fee_type = $fee_type;
    }

    /**
     * @return string
     */
    public function getFeeRefundAmount()
    {
        return $this->fee_refund_amount;
    }

    /**
     * @return FeeType
     */
    public function getFeeType()
    {
        return $this->fee_type;
    }

    /**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this));
    }
}