<?php
/**
 * CustomerAccountApi
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Api;

use Orbipay\PaymentsApi\Client\Util\AuthenticationUtil;
use Orbipay\PaymentsApi\Client\Constant\HttpParamConstants;
use Orbipay\PaymentsApi\Client\Constant\RestConstants;
use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Orbipay\PaymentsApi\Client\Util\CommonUtil;
use Orbipay\PaymentsApi\Client\Util\RequestWrapper;
use Psr\Http\Message\RequestInterface;
use Psr\Http\Message\ResponseInterface;
use Orbipay\PaymentsApi\Client\Swagger\ApiException;
use Orbipay\PaymentsApi\Client\Swagger\Configuration;
use Orbipay\PaymentsApi\Client\Swagger\HeaderSelector;
use Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * CustomerAccountApi Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerAccountApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @param ClientInterface $client
     * @param Configuration $config
     * @param HeaderSelector $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    )
    {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation getCustomerAccount
     *
     * Get Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function getCustomerAccount($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
        $response = $this->getCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $x_opay_headers);
        return $response;
    }

    /**
     * Operation getCustomerAccountWithHttpInfo
     *
     * Get Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function getCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse';

        /** @var RequestInterface $request */
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->getCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'getCustomerAccount'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function getCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
        $method = 'GET';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer_account !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER_ACCOUNT' . '}',
                ObjectSerializer::toPathValue($id_customer_account),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;

            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation retrieveCustomerAccounts
     *
     * Retrieve Customer Accounts
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param array|null $form_params
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws ApiException on non-2xx response
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrieveCustomerAccounts($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $x_opay_headers = null, $page_size = null, array $form_params = null)
    {
        $account_number = null;
        $status = null;

        if (isset($form_params)) {
            $account_number = $form_params['account_number'];
            $status = $form_params['status'];
        }

        $response = $this->retrieveCustomerAccountsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $x_opay_headers, $page_size, $account_number, $status);
        return $response;
    }

    /**
     * Operation retrieveCustomerAccountsWithHttpInfo
     *
     * Retrieve Customer Accounts
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $account_number The Account Number to get details of. (optional)
     * @param  string $status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrieveCustomerAccountsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $x_opay_headers = null, $page_size = null, $account_number = null, $status = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrieveCustomerAccountsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $x_opay_headers, $page_size, $account_number, $status);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'retrieveCustomerAccounts'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $account_number The Account Number to get details of. (optional)
     * @param  string $status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function retrieveCustomerAccountsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $x_opay_headers = null, $page_size = null, $account_number = null, $status = null)
    {
        $method = 'POST';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/lists';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($page_size !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($page_size);
        }
        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // form params
        if ($account_number !== null) {
            $formParams['account_number'] = ObjectSerializer::toFormValue($account_number);
        }
        // form params
        if ($status !== null) {
            $formParams['status'] = ObjectSerializer::toFormValue($status);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $httpBody, $hash, $masked_authentication_data];
    }

    /**
     * Operation retrieveCustomerAccountsPage
     *
     * Retrieve Customer Accounts Page
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $to_index To fetch the next set of objects that start after this object (optional)
     * @param  string $from_index To fetch the previous set of objects that end at this object (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrieveCustomerAccountsPage($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $to_index = null, $from_index = null)
    {
        $response = $this->retrieveCustomerAccountsPageWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $query_id, $x_opay_headers, $page_size, $to_index, $from_index);
        return $response;
    }

    /**
     * Operation retrieveCustomerAccountsPageWithHttpInfo
     *
     * Retrieve Customer Accounts Page
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $to_index To fetch the next set of objects that start after this object (optional)
     * @param  string $from_index To fetch the previous set of objects that end at this object (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrieveCustomerAccountsPageWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $to_index = null, $from_index = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrieveCustomerAccountsPageRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $query_id, $x_opay_headers, $page_size, $to_index, $from_index);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountsResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'retrieveCustomerAccountsPage'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $to_index To fetch the next set of objects that start after this object (optional)
     * @param  string $from_index To fetch the previous set of objects that end at this object (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function retrieveCustomerAccountsPageRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $to_index = null, $from_index = null)
    {
        $method = 'GET';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/lists';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($page_size !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($page_size);
        }
        // query params
        if ($query_id !== null) {
            $queryParams['query_id'] = ObjectSerializer::toQueryValue($query_id);
        }
        // query params
        if ($to_index !== null) {
            $queryParams['to_index'] = ObjectSerializer::toQueryValue($to_index);
        }
        // query params
        if ($from_index !== null) {
            $queryParams['from_index'] = ObjectSerializer::toQueryValue($from_index);
        }
        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        $timeoutValue = getenv(RestConstants::ORBIPAY_API_CLIENT_TIMEOUT_SECONDS);
        if (is_numeric($timeoutValue) && ((float)$timeoutValue) > 0) {
            $options[RequestOptions::TIMEOUT] = (float)$timeoutValue;
        } else {
            $options[RequestOptions::TIMEOUT] = RestConstants::DEFAULT_HTTP_TIMEOUT;
        }

        return $options;
    }

    /**
     * Operation renewCustomerAccount
     *
     * Renew Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by an agent or a customer service representative belonging to the biller/client organization, then the requestor_type should be set to \&quot;client_agent\&quot;. It should be noted that there should be a user in the EBPP Portal (or Payment Center) corresponding to this user.&lt;/br&gt;If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;client_agent\&quot;, the requestor should be the login id for the client agent user to the Orbipay EBPP Portal / Payment Center.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Swagger\Client\Model\RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\CustomerAccountResponse
     */
    public function renewCustomerAccount($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
        $response = $this->renewCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers);
        return $response;
    }

    /**
     * Operation renewCustomerAccountWithHttpInfo
     *
     * Renew Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by an agent or a customer service representative belonging to the biller/client organization, then the requestor_type should be set to \&quot;client_agent\&quot;. It should be noted that there should be a user in the EBPP Portal (or Payment Center) corresponding to this user.&lt;/br&gt;If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;client_agent\&quot;, the requestor should be the login id for the client agent user to the Orbipay EBPP Portal / Payment Center.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Swagger\Client\Model\RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function renewCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->renewCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'renewCustomerAccount'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by an agent or a customer service representative belonging to the biller/client organization, then the requestor_type should be set to \&quot;client_agent\&quot;. It should be noted that there should be a user in the EBPP Portal (or Payment Center) corresponding to this user.&lt;/br&gt;If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;client_agent\&quot;, the requestor should be the login id for the client agent user to the Orbipay EBPP Portal / Payment Center.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Swagger\Client\Model\RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function renewCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
        $method = 'POST';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}/renew';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer_account !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER_ACCOUNT' . '}',
                ObjectSerializer::toPathValue($id_customer_account),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($renew_customer_account_request)) {
            $_tempBody = $renew_customer_account_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;

            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);

        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }


}
