<?php
/**
 * PaymentSetupApi
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Orbipay\PaymentsApi\Client\Constant\HttpParamConstants;
use Orbipay\PaymentsApi\Client\Constant\RestConstants;
use Orbipay\PaymentsApi\Client\Util\AuthenticationUtil;
use Orbipay\PaymentsApi\Client\Util\CommonUtil;
use Orbipay\PaymentsApi\Client\Util\RequestWrapper;
use Psr\Http\Message\ResponseInterface;
use Orbipay\PaymentsApi\Client\Swagger\ApiException;
use Orbipay\PaymentsApi\Client\Swagger\Configuration;
use Orbipay\PaymentsApi\Client\Swagger\HeaderSelector;
use Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * PaymentSetupApi Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PaymentSetupApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @param ClientInterface $client
     * @param Configuration $config
     * @param HeaderSelector $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    )
    {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation createPaymentSetup
     *
     * Create Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\CreatePaymentSetupRequest $create_payment_setup_request JSON containing all the fields required to create a recurring payment setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function createPaymentSetup($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $create_payment_setup_request, $x_opay_headers = null)
    {
        $response = $this->createPaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $create_payment_setup_request, $x_opay_headers);
        return $response;
    }

    /**
     * Operation createPaymentSetupWithHttpInfo
     *
     * Create Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\CreatePaymentSetupRequest $create_payment_setup_request JSON containing all the fields required to create a recurring payment setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function createPaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $create_payment_setup_request, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->createPaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $create_payment_setup_request, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'createPaymentSetup'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\CreatePaymentSetupRequest $create_payment_setup_request JSON containing all the fields required to create a recurring payment setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function createPaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_customer, $create_payment_setup_request, $x_opay_headers = null)
    {
        $method = 'POST';
        $resourcePath = '/customers/{ID_CUSTOMER}/paymentsetups';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($create_payment_setup_request)) {
            $_tempBody = $create_payment_setup_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation deletePaymentSetup
     *
     * Delete Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\DeletePaymentSetupRequest $delete_payment_setup_request JSON containing all the fields required to delete a payment. Setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\DeleteResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function deletePaymentSetup($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $delete_payment_setup_request, $x_opay_headers = null)
    {
        $response = $this->deletePaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $delete_payment_setup_request, $x_opay_headers);
        return $response;
    }

    /**
     * Operation deletePaymentSetupWithHttpInfo
     *
     * Delete Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\DeletePaymentSetupRequest $delete_payment_setup_request JSON containing all the fields required to delete a payment. Setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\DeleteResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function deletePaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $delete_payment_setup_request, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\DeleteResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->deletePaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $delete_payment_setup_request, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\DeleteResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'deletePaymentSetup'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\DeletePaymentSetupRequest $delete_payment_setup_request JSON containing all the fields required to delete a payment. Setup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function deletePaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $delete_payment_setup_request, $x_opay_headers = null)
    {
        $method = 'DELETE';
        $resourcePath = '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_payment_setup !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_PAYMENT_SETUP' . '}',
                ObjectSerializer::toPathValue($id_payment_setup),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($delete_payment_setup_request)) {
            $_tempBody = $delete_payment_setup_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation getPaymentSetup
     *
     * Get Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function getPaymentSetup($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $x_opay_headers = null)
    {
        $response = $this->getPaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $x_opay_headers);
        return $response;
    }

    /**
     * Operation getPaymentSetupWithHttpInfo
     *
     * Get Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function getPaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->getPaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'getPaymentSetup'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function getPaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $x_opay_headers = null)
    {
        $method = 'GET';
        $resourcePath = '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_payment_setup !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_PAYMENT_SETUP' . '}',
                ObjectSerializer::toPathValue($id_payment_setup),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation retrievePaymentSetups
     *
     * Retrieve Payment Setups
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (optional)
     * @param  string $id_funding_account The unique identifier assigned by Orbipay to the funding account (optional)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the customer account (optional)
     * @param  string $confirmation_number The confirmation number or reference provided to the customer for the successful payment. (optional)
     * @param  string $status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $payment_setup_schedule_type The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $from_date The date from which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $to_date The date upto which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param string $query_id
     * @param string $to_index
     * @param string $from_index
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrievePaymentSetups($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $x_opay_headers = null, $id_customer = null, $id_funding_account = null, $id_customer_account = null, $confirmation_number = null, $status = null, $payment_setup_schedule_type = null, $from_date = null, $to_date = null, $page_size = null, $query_id = null, $to_index = null, $from_index = null)
    {
        $response = $this->retrievePaymentSetupsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $x_opay_headers, $id_customer, $id_funding_account, $id_customer_account, $confirmation_number, $status, $payment_setup_schedule_type, $from_date, $to_date, $page_size, $query_id, $to_index, $from_index);
        return $response;
    }

    /**
     * Operation retrievePaymentSetupsWithHttpInfo
     *
     * Retrieve Payment Setups
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (optional)
     * @param  string $id_funding_account The unique identifier assigned by Orbipay to the funding account (optional)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the customer account (optional)
     * @param  string $confirmation_number The confirmation number or reference provided to the customer for the successful payment. (optional)
     * @param  string $status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $payment_setup_schedule_type The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $from_date The date from which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $to_date The date upto which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param string $query_id
     * @param string $to_index
     * @param string $from_index
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupsResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function retrievePaymentSetupsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $x_opay_headers = null, $id_customer = null, $id_funding_account = null, $id_customer_account = null, $confirmation_number = null, $status = null, $payment_setup_schedule_type = null, $from_date = null, $to_date = null, $page_size = null, $query_id = null, $to_index = null, $from_index = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupsResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrievePaymentSetupsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $x_opay_headers, $id_customer, $id_funding_account, $id_customer_account, $confirmation_number, $status, $payment_setup_schedule_type, $from_date, $to_date, $page_size, $query_id, $to_index, $from_index);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupsResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'retrievePaymentSetups'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the ISO 8601 format, namely, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;.&lt;br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17+00:00&lt;/i&gt;. Please ensure that consecutive spaces are not used in the timestamp even if permitted as per the ISO 8601 format. (required)
     * @param  string $idempotent_request_key The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. Please note that requestor types &#39;customer&#39; and &#39;external_user&#39; are supported only by the Payments API. The requestor type &#39;payee&#39; is supported only by the Payouts API. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (optional)
     * @param  string $id_funding_account The unique identifier assigned by Orbipay to the funding account (optional)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the customer account (optional)
     * @param  string $confirmation_number The confirmation number or reference provided to the customer for the successful payment. (optional)
     * @param  string $status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $payment_setup_schedule_type The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     * @param  string $from_date The date from which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $to_date The date upto which recurring payments setup, matching the criteria specified, need to be retrieved. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param string $query_id
     * @param string $to_index
     * @param string $from_index
     * @return array
     * @throws ApiException
     */
    protected function retrievePaymentSetupsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $x_opay_headers = null, $id_customer = null, $id_funding_account = null, $id_customer_account = null, $confirmation_number = null, $status = null, $payment_setup_schedule_type = null, $from_date = null, $to_date = null, $page_size = null, $query_id = null, $to_index = null, $from_index = null)
    {
        $method = 'GET';
        $resourcePath = '/paymentsetups';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($id_customer !== null) {
            $queryParams['id_customer'] = ObjectSerializer::toQueryValue($id_customer);
        }
        // query params
        if ($id_funding_account !== null) {
            $queryParams['id_funding_account'] = ObjectSerializer::toQueryValue($id_funding_account);
        }
        // query params
        if ($id_customer_account !== null) {
            $queryParams['id_customer_account'] = ObjectSerializer::toQueryValue($id_customer_account);
        }
        // query params
        if ($confirmation_number !== null) {
            $queryParams['confirmation_number'] = ObjectSerializer::toQueryValue($confirmation_number);
        }
        // query params
        if ($status !== null) {
            $queryParams['status'] = ObjectSerializer::toQueryValue($status);
        }
        // query params
        if ($payment_setup_schedule_type !== null) {
            $queryParams['payment_setup_schedule_type'] = ObjectSerializer::toQueryValue($payment_setup_schedule_type);
        }
        // query params
        if ($from_date !== null) {
            $queryParams['from_date'] = ObjectSerializer::toQueryValue($from_date);
        }
        // query params
        if ($to_date !== null) {
            $queryParams['to_date'] = ObjectSerializer::toQueryValue($to_date);
        }
        // query params
        if ($page_size !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($page_size);
        }
        // query params
        if ($query_id !== null) {
            $queryParams['query_id'] = ObjectSerializer::toQueryValue($query_id);
        }
        // query params
        if ($to_index !== null) {
            $queryParams['to_index'] = ObjectSerializer::toQueryValue($to_index);
        }
        // query params
        if ($from_index !== null) {
            $queryParams['from_index'] = ObjectSerializer::toQueryValue($from_index);
        }
        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        $timeoutValue = getenv(RestConstants::ORBIPAY_API_CLIENT_TIMEOUT_SECONDS);
        if (is_numeric($timeoutValue) && ((float)$timeoutValue) > 0) {
            $options[RequestOptions::TIMEOUT] = (float)$timeoutValue;
        } else {
            $options[RequestOptions::TIMEOUT] = RestConstants::DEFAULT_HTTP_TIMEOUT;
        }

        return $options;
    }

    /**
     * Operation updatePaymentSetup
     *
     * Update Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\UpdatePaymentSetupRequest $update_payment_setup_request Details of the Payment Setup to be updated. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function updatePaymentSetup($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $update_payment_setup_request, $x_opay_headers = null)
    {
        $response = $this->updatePaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $update_payment_setup_request, $x_opay_headers);
        return $response;
    }

    /**
     * Operation updatePaymentSetupWithHttpInfo
     *
     * Update Payment Setup
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\UpdatePaymentSetupRequest $update_payment_setup_request Details of the Payment Setup to be updated. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\Swagger\ApiException on non-2xx response
     * @return array of \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse, HTTP status code, HTTP response headers (array of strings)
     * @throws \GuzzleHttp\Exception\GuzzleException
     */
    public function updatePaymentSetupWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $update_payment_setup_request, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data)  = $this->updatePaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $update_payment_setup_request, $x_opay_headers);

        try {
            $options = $this->createHttpClientOption();
            try {
                /** @var ResponseInterface $response */
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(RequestWrapper::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentSetupResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                default:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Swagger\Model\ErrorResponseVO',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Create request for operation 'updatePaymentSetup'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;. (required)
     * @param  string $requestor_type Type of the requestor of the API. (required)
     * @param  string $id_payment_setup The unique identifier assigned by Orbipay to the payment setup. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  \Orbipay\PaymentsApi\Client\Swagger\Model\UpdatePaymentSetupRequest $update_payment_setup_request Details of the Payment Setup to be updated. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @return array
     * @throws ApiException
     */
    protected function updatePaymentSetupRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor, $requestor_type, $id_payment_setup, $id_customer, $update_payment_setup_request, $x_opay_headers = null)
    {
        $method = 'PUT';
        $resourcePath = '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_payment_setup !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_PAYMENT_SETUP' . '}',
                ObjectSerializer::toPathValue($id_payment_setup),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($update_payment_setup_request)) {
            $_tempBody = $update_payment_setup_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams[HttpParamConstants::AUTHORIZATION_HEADER] = RestConstants::ORBIPAY_HASHING_ALGORITHM . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }
}