<?php
/**
 * AddressVO
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * AddressVO Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AddressVO implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
     * The original name of the model.
     *
     * @var string
     */
    protected static $swaggerModelName = 'AddressVO';

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @var string[]
     */
    protected static $swaggerTypes = [
        'address_line1' => 'string',
        'address_line2' => 'string',
        'address_city' => 'string',
        'address_state' => 'string',
        'address_country' => 'string',
        'address_zip1' => 'string',
        'address_zip2' => 'string'
    ];

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @var string[]
     */
    protected static $swaggerFormats = [
        'address_line1' => null,
        'address_line2' => null,
        'address_city' => null,
        'address_state' => null,
        'address_country' => null,
        'address_zip1' => null,
        'address_zip2' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'address_line1' => 'address_line1',
        'address_line2' => 'address_line2',
        'address_city' => 'address_city',
        'address_state' => 'address_state',
        'address_country' => 'address_country',
        'address_zip1' => 'address_zip1',
        'address_zip2' => 'address_zip2'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'address_line1' => 'setAddressLine1',
        'address_line2' => 'setAddressLine2',
        'address_city' => 'setAddressCity',
        'address_state' => 'setAddressState',
        'address_country' => 'setAddressCountry',
        'address_zip1' => 'setAddressZip1',
        'address_zip2' => 'setAddressZip2'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'address_line1' => 'getAddressLine1',
        'address_line2' => 'getAddressLine2',
        'address_city' => 'getAddressCity',
        'address_state' => 'getAddressState',
        'address_country' => 'getAddressCountry',
        'address_zip1' => 'getAddressZip1',
        'address_zip2' => 'getAddressZip2'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['address_line1'] = isset($data['address_line1']) ? $data['address_line1'] : null;
        $this->container['address_line2'] = isset($data['address_line2']) ? $data['address_line2'] : null;
        $this->container['address_city'] = isset($data['address_city']) ? $data['address_city'] : null;
        $this->container['address_state'] = isset($data['address_state']) ? $data['address_state'] : null;
        $this->container['address_country'] = isset($data['address_country']) ? $data['address_country'] : null;
        $this->container['address_zip1'] = isset($data['address_zip1']) ? $data['address_zip1'] : null;
        $this->container['address_zip2'] = isset($data['address_zip2']) ? $data['address_zip2'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['address_line1']) && (strlen($this->container['address_line1']) > 100)) {
            $invalidProperties[] = "invalid value for 'address_line1', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['address_line1']) && (strlen($this->container['address_line1']) < 0)) {
            $invalidProperties[] = "invalid value for 'address_line1', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['address_line1']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['address_line1'])) {
            $invalidProperties[] = "invalid value for 'address_line1', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['address_line2']) && (strlen($this->container['address_line2']) > 100)) {
            $invalidProperties[] = "invalid value for 'address_line2', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['address_line2']) && (strlen($this->container['address_line2']) < 0)) {
            $invalidProperties[] = "invalid value for 'address_line2', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['address_line2']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['address_line2'])) {
            $invalidProperties[] = "invalid value for 'address_line2', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['address_city']) && (strlen($this->container['address_city']) > 20)) {
            $invalidProperties[] = "invalid value for 'address_city', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['address_city']) && (strlen($this->container['address_city']) < 0)) {
            $invalidProperties[] = "invalid value for 'address_city', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['address_city']) && !preg_match("/[0-9a-zA-Z ,.-]+/", $this->container['address_city'])) {
            $invalidProperties[] = "invalid value for 'address_city', must be conform to the pattern /[0-9a-zA-Z ,.-]+/.";
        }

        if (!is_null($this->container['address_state']) && (strlen($this->container['address_state']) > 2)) {
            $invalidProperties[] = "invalid value for 'address_state', the character length must be smaller than or equal to 2.";
        }

        if (!is_null($this->container['address_state']) && (strlen($this->container['address_state']) < 2)) {
            $invalidProperties[] = "invalid value for 'address_state', the character length must be bigger than or equal to 2.";
        }

        if (!is_null($this->container['address_state']) && !preg_match("/[a-zA-Z]{2}/", $this->container['address_state'])) {
            $invalidProperties[] = "invalid value for 'address_state', must be conform to the pattern /[a-zA-Z]{2}/.";
        }

        if (!is_null($this->container['address_country']) && (strlen($this->container['address_country']) > 3)) {
            $invalidProperties[] = "invalid value for 'address_country', the character length must be smaller than or equal to 3.";
        }

        if (!is_null($this->container['address_country']) && (strlen($this->container['address_country']) < 3)) {
            $invalidProperties[] = "invalid value for 'address_country', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['address_country']) && !preg_match("/[a-zA-Z]{3}/", $this->container['address_country'])) {
            $invalidProperties[] = "invalid value for 'address_country', must be conform to the pattern /[a-zA-Z]{3}/.";
        }

        if (!is_null($this->container['address_zip1']) && (strlen($this->container['address_zip1']) > 5)) {
            $invalidProperties[] = "invalid value for 'address_zip1', the character length must be smaller than or equal to 5.";
        }

        if (!is_null($this->container['address_zip1']) && (strlen($this->container['address_zip1']) < 5)) {
            $invalidProperties[] = "invalid value for 'address_zip1', the character length must be bigger than or equal to 5.";
        }

        if (!is_null($this->container['address_zip1']) && !preg_match("/[0-9]{5}/", $this->container['address_zip1'])) {
            $invalidProperties[] = "invalid value for 'address_zip1', must be conform to the pattern /[0-9]{5}/.";
        }

        if (!is_null($this->container['address_zip2']) && (strlen($this->container['address_zip2']) > 4)) {
            $invalidProperties[] = "invalid value for 'address_zip2', the character length must be smaller than or equal to 4.";
        }

        if (!is_null($this->container['address_zip2']) && (strlen($this->container['address_zip2']) < 4)) {
            $invalidProperties[] = "invalid value for 'address_zip2', the character length must be bigger than or equal to 4.";
        }

        if (!is_null($this->container['address_zip2']) && !preg_match("/[0-9]{4}/", $this->container['address_zip2'])) {
            $invalidProperties[] = "invalid value for 'address_zip2', must be conform to the pattern /[0-9]{4}/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['address_line1']) > 100) {
            return false;
        }
        if (strlen($this->container['address_line1']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['address_line1'])) {
            return false;
        }
        if (strlen($this->container['address_line2']) > 100) {
            return false;
        }
        if (strlen($this->container['address_line2']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['address_line2'])) {
            return false;
        }
        if (strlen($this->container['address_city']) > 20) {
            return false;
        }
        if (strlen($this->container['address_city']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z ,.-]+/", $this->container['address_city'])) {
            return false;
        }
        if (strlen($this->container['address_state']) > 2) {
            return false;
        }
        if (strlen($this->container['address_state']) < 2) {
            return false;
        }
        if (!preg_match("/[a-zA-Z]{2}/", $this->container['address_state'])) {
            return false;
        }
        if (strlen($this->container['address_country']) > 3) {
            return false;
        }
        if (strlen($this->container['address_country']) < 3) {
            return false;
        }
        if (!preg_match("/[a-zA-Z]{3}/", $this->container['address_country'])) {
            return false;
        }
        if (strlen($this->container['address_zip1']) > 5) {
            return false;
        }
        if (strlen($this->container['address_zip1']) < 5) {
            return false;
        }
        if (!preg_match("/[0-9]{5}/", $this->container['address_zip1'])) {
            return false;
        }
        if (strlen($this->container['address_zip2']) > 4) {
            return false;
        }
        if (strlen($this->container['address_zip2']) < 4) {
            return false;
        }
        if (!preg_match("/[0-9]{4}/", $this->container['address_zip2'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets address_line1
     *
     * @return string
     */
    public function getAddressLine1()
    {
        return $this->container['address_line1'];
    }

    /**
     * Sets address_line1
     *
     * @param string $address_line1 address_line1
     *
     * @return $this
     */
    public function setAddressLine1($address_line1)
    {
        $this->container['address_line1'] = $address_line1;

        return $this;
    }

    /**
     * Gets address_line2
     *
     * @return string
     */
    public function getAddressLine2()
    {
        return $this->container['address_line2'];
    }

    /**
     * Sets address_line2
     *
     * @param string $address_line2 address_line2
     *
     * @return $this
     */
    public function setAddressLine2($address_line2)
    {
        $this->container['address_line2'] = $address_line2;

        return $this;
    }

    /**
     * Gets address_city
     *
     * @return string
     */
    public function getAddressCity()
    {
        return $this->container['address_city'];
    }

    /**
     * Sets address_city
     *
     * @param string $address_city address_city
     *
     * @return $this
     */
    public function setAddressCity($address_city)
    {
        $this->container['address_city'] = $address_city;

        return $this;
    }

    /**
     * Gets address_state
     *
     * @return string
     */
    public function getAddressState()
    {
        return $this->container['address_state'];
    }

    /**
     * Sets address_state
     *
     * @param string $address_state The 2-letter state code used by the US Postal Service.
     *
     * @return $this
     */
    public function setAddressState($address_state)
    {
        $this->container['address_state'] = $address_state;

        return $this;
    }

    /**
     * Gets address_country
     *
     * @return string
     */
    public function getAddressCountry()
    {
        return $this->container['address_country'];
    }

    /**
     * Sets address_country
     *
     * @param string $address_country The 3 digit ISO country code.
     *
     * @return $this
     */
    public function setAddressCountry($address_country)
    {
        $this->container['address_country'] = $address_country;

        return $this;
    }

    /**
     * Gets address_zip1
     *
     * @return string
     */
    public function getAddressZip1()
    {
        return $this->container['address_zip1'];
    }

    /**
     * Sets address_zip1
     *
     * @param string $address_zip1 The 5 digit postal code used by the US Postal Service.
     *
     * @return $this
     */
    public function setAddressZip1($address_zip1)
    {
        $this->container['address_zip1'] = $address_zip1;

        return $this;
    }

    /**
     * Gets address_zip2
     *
     * @return string
     */
    public function getAddressZip2()
    {
        return $this->container['address_zip2'];
    }

    /**
     * Sets address_zip2
     *
     * @param string $address_zip2 The 4 digit add-on code used, in addition to the 5 digit postal code, by the US Postal Service.
     *
     * @return $this
     */
    public function setAddressZip2($address_zip2)
    {
        $this->container['address_zip2'] = $address_zip2;

        return $this;
    }

    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed $value Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


