<?php
/**
 * CreatePaymentSetupRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * CreatePaymentSetupRequest Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CreatePaymentSetupRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'CreatePaymentSetupRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_setup_reference' => 'string',
        'payment_setup_schedule_type' => 'string',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest',
        'customer' => '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerMinimalRequest',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountMinimalRequest',
        'payment_schedule' => '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentScheduleVO',
        'comments' => 'string',
        'custom_fields' => 'object'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_setup_reference' => null,
        'payment_setup_schedule_type' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'fee' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_schedule' => null,
        'comments' => null,
        'custom_fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_setup_reference' => 'payment_setup_reference',
        'payment_setup_schedule_type' => 'payment_setup_schedule_type',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'fee' => 'fee',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_schedule' => 'payment_schedule',
        'comments' => 'comments',
        'custom_fields' => 'custom_fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_setup_reference' => 'setPaymentSetupReference',
        'payment_setup_schedule_type' => 'setPaymentSetupScheduleType',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'fee' => 'setFee',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_schedule' => 'setPaymentSchedule',
        'comments' => 'setComments',
        'custom_fields' => 'setCustomFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_setup_reference' => 'getPaymentSetupReference',
        'payment_setup_schedule_type' => 'getPaymentSetupScheduleType',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'fee' => 'getFee',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_schedule' => 'getPaymentSchedule',
        'comments' => 'getComments',
        'custom_fields' => 'getCustomFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT = 'variable_recurring_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT = 'autopay_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN = 'payment_plan';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentSetupScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['payment_setup_reference'] = isset($data['payment_setup_reference']) ? $data['payment_setup_reference'] : null;
        $this->container['payment_setup_schedule_type'] = isset($data['payment_setup_schedule_type']) ? $data['payment_setup_schedule_type'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['payment_schedule'] = isset($data['payment_schedule']) ? $data['payment_schedule'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['payment_setup_reference']) && (strlen($this->container['payment_setup_reference']) > 50)) {
            $invalidProperties[] = "invalid value for 'payment_setup_reference', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['payment_setup_reference']) && (strlen($this->container['payment_setup_reference']) < 0)) {
            $invalidProperties[] = "invalid value for 'payment_setup_reference', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['payment_setup_reference']) && !preg_match("/[0-9a-zA-Z._-]{0,50}/", $this->container['payment_setup_reference'])) {
            $invalidProperties[] = "invalid value for 'payment_setup_reference', must be conform to the pattern /[0-9a-zA-Z._-]{0,50}/.";
        }

        if ($this->container['payment_setup_schedule_type'] === null) {
            $invalidProperties[] = "'payment_setup_schedule_type' can't be null";
        }
        $allowedValues = $this->getPaymentSetupScheduleTypeAllowableValues();
        if (!in_array($this->container['payment_setup_schedule_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_setup_schedule_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) > 17)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be smaller than or equal to 17.";
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) < 1)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['amount']) && !preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            $invalidProperties[] = "invalid value for 'amount', must be conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) > 4)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be smaller than or equal to 4.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) < 3)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['card_cvv_number']) && !preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', must be conform to the pattern /[0-9]{3,4}/.";
        }

        if ($this->container['customer'] === null) {
            $invalidProperties[] = "'customer' can't be null";
        }
        if ($this->container['funding_account'] === null) {
            $invalidProperties[] = "'funding_account' can't be null";
        }
        if ($this->container['customer_account'] === null) {
            $invalidProperties[] = "'customer_account' can't be null";
        }
        if ($this->container['payment_schedule'] === null) {
            $invalidProperties[] = "'payment_schedule' can't be null";
        }
        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) > 100)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) < 0)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['comments']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            $invalidProperties[] = "invalid value for 'comments', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['payment_setup_reference']) > 50) {
            return false;
        }
        if (strlen($this->container['payment_setup_reference']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z._-]{0,50}/", $this->container['payment_setup_reference'])) {
            return false;
        }
        if ($this->container['payment_setup_schedule_type'] === null) {
            return false;
        }
        $allowedValues = $this->getPaymentSetupScheduleTypeAllowableValues();
        if (!in_array($this->container['payment_setup_schedule_type'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['amount']) > 17) {
            return false;
        }
        if (strlen($this->container['amount']) < 1) {
            return false;
        }
        if (!preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) > 4) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) < 3) {
            return false;
        }
        if (!preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            return false;
        }
        if ($this->container['customer'] === null) {
            return false;
        }
        if ($this->container['funding_account'] === null) {
            return false;
        }
        if ($this->container['customer_account'] === null) {
            return false;
        }
        if ($this->container['payment_schedule'] === null) {
            return false;
        }
        if (strlen($this->container['comments']) > 100) {
            return false;
        }
        if (strlen($this->container['comments']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets payment_setup_reference
     *
     * @return string
     */
    public function getPaymentSetupReference()
    {
        return $this->container['payment_setup_reference'];
    }

    /**
     * Sets payment_setup_reference
     *
     * @param string $payment_setup_reference The unique identifier in the client system for the paymentSetup.
     *
     * @return $this
     */
    public function setPaymentSetupReference($payment_setup_reference)
    {
        $this->container['payment_setup_reference'] = $payment_setup_reference;

        return $this;
    }

    /**
     * Gets payment_setup_schedule_type
     *
     * @return string
     */
    public function getPaymentSetupScheduleType()
    {
        return $this->container['payment_setup_schedule_type'];
    }

    /**
     * Sets payment_setup_schedule_type
     *
     * @param string $payment_setup_schedule_type The schedule type for the payment setup.
     *
     * @return $this
     */
    public function setPaymentSetupScheduleType($payment_setup_schedule_type)
    {
        $this->container['payment_setup_schedule_type'] = $payment_setup_schedule_type;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerMinimalRequest
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerMinimalRequest $payer customer
     *
     * @return $this
     */
    public function setCustomer($payer)
    {
        $this->container['customer'] = $payer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountMinimalRequest
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountMinimalRequest $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets payment_schedule
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentScheduleVO
     */
    public function getPaymentSchedule()
    {
        return $this->container['payment_schedule'];
    }

    /**
     * Sets payment_schedule
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentScheduleVO $payment_schedule payment_schedule
     *
     * @return $this
     */
    public function setPaymentSchedule($payment_schedule)
    {
        $this->container['payment_schedule'] = $payment_schedule;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments comments
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets custom_fields
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     * @param object $custom_fields
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


