<?php
/**
 * CustomerSnapshotResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * CustomerSnapshotResponse Class Doc Comment
 *
 * @category Class
 * @description The customer making the payment
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerSnapshotResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'CustomerSnapshotResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'first_name' => 'string',
        'last_name' => 'string',
        'middle_name' => 'string',
        'email' => 'string',
        'home_phone' => 'string',
        'address' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'first_name' => null,
        'last_name' => null,
        'middle_name' => null,
        'email' => null,
        'home_phone' => null,
        'address' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'first_name' => 'first_name',
        'last_name' => 'last_name',
        'middle_name' => 'middle_name',
        'email' => 'email',
        'home_phone' => 'home_phone',
        'address' => 'address'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'first_name' => 'setFirstName',
        'last_name' => 'setLastName',
        'middle_name' => 'setMiddleName',
        'email' => 'setEmail',
        'home_phone' => 'setHomePhone',
        'address' => 'setAddress'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'first_name' => 'getFirstName',
        'last_name' => 'getLastName',
        'middle_name' => 'getMiddleName',
        'email' => 'getEmail',
        'home_phone' => 'getHomePhone',
        'address' => 'getAddress'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['first_name'] = isset($data['first_name']) ? $data['first_name'] : null;
        $this->container['last_name'] = isset($data['last_name']) ? $data['last_name'] : null;
        $this->container['middle_name'] = isset($data['middle_name']) ? $data['middle_name'] : null;
        $this->container['email'] = isset($data['email']) ? $data['email'] : null;
        $this->container['home_phone'] = isset($data['home_phone']) ? $data['home_phone'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['id']) && (strlen($this->container['id']) > 20)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['id']) && !preg_match("/[0-9]{0,20}/", $this->container['id'])) {
            $invalidProperties[] = "invalid value for 'id', must be conform to the pattern /[0-9]{0,20}/.";
        }

        if (!is_null($this->container['first_name']) && (strlen($this->container['first_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'first_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['first_name']) && (strlen($this->container['first_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'first_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['first_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['first_name'])) {
            $invalidProperties[] = "invalid value for 'first_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['last_name']) && (strlen($this->container['last_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'last_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['last_name']) && (strlen($this->container['last_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'last_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['last_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['last_name'])) {
            $invalidProperties[] = "invalid value for 'last_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['middle_name']) && (strlen($this->container['middle_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'middle_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['middle_name']) && (strlen($this->container['middle_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'middle_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['middle_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['middle_name'])) {
            $invalidProperties[] = "invalid value for 'middle_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['email']) && (strlen($this->container['email']) > 100)) {
            $invalidProperties[] = "invalid value for 'email', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['email']) && !preg_match("/[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/", $this->container['email'])) {
            $invalidProperties[] = "invalid value for 'email', must be conform to the pattern /[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/.";
        }

        if (!is_null($this->container['home_phone']) && (strlen($this->container['home_phone']) > 10)) {
            $invalidProperties[] = "invalid value for 'home_phone', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['home_phone']) && (strlen($this->container['home_phone']) < 10)) {
            $invalidProperties[] = "invalid value for 'home_phone', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['home_phone']) && !preg_match("/[0-9]{10}/", $this->container['home_phone'])) {
            $invalidProperties[] = "invalid value for 'home_phone', must be conform to the pattern /[0-9]{10}/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['id']) > 20) {
            return false;
        }
        if (!preg_match("/[0-9]{0,20}/", $this->container['id'])) {
            return false;
        }
        if (strlen($this->container['first_name']) > 60) {
            return false;
        }
        if (strlen($this->container['first_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['first_name'])) {
            return false;
        }
        if (strlen($this->container['last_name']) > 60) {
            return false;
        }
        if (strlen($this->container['last_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['last_name'])) {
            return false;
        }
        if (strlen($this->container['middle_name']) > 60) {
            return false;
        }
        if (strlen($this->container['middle_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['middle_name'])) {
            return false;
        }
        if (strlen($this->container['email']) > 100) {
            return false;
        }
        if (!preg_match("/[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/", $this->container['email'])) {
            return false;
        }
        if (strlen($this->container['home_phone']) > 10) {
            return false;
        }
        if (strlen($this->container['home_phone']) < 10) {
            return false;
        }
        if (!preg_match("/[0-9]{10}/", $this->container['home_phone'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by Orbipay to the customer.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url The URL that can be used to fetch the details of the customer.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets first_name
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->container['first_name'];
    }

    /**
     * Sets first_name
     *
     * @param string $first_name The first name of the customer.
     *
     * @return $this
     */
    public function setFirstName($first_name)
    {
        $this->container['first_name'] = $first_name;

        return $this;
    }

    /**
     * Gets last_name
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->container['last_name'];
    }

    /**
     * Sets last_name
     *
     * @param string $last_name The last name of the customer.
     *
     * @return $this
     */
    public function setLastName($last_name)
    {
        $this->container['last_name'] = $last_name;

        return $this;
    }

    /**
     * Gets middle_name
     *
     * @return string
     */
    public function getMiddleName()
    {
        return $this->container['middle_name'];
    }

    /**
     * Sets middle_name
     *
     * @param string $middle_name The middle initial of the customer.
     *
     * @return $this
     */
    public function setMiddleName($middle_name)
    {
        $this->container['middle_name'] = $middle_name;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string $email The email address of the customer.
     *
     * @return $this
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets home_phone
     *
     * @return string
     */
    public function getHomePhone()
    {
        return $this->container['home_phone'];
    }

    /**
     * Sets home_phone
     *
     * @param string $home_phone The home phone number of the customer.
     *
     * @return $this
     */
    public function setHomePhone($home_phone)
    {
        $this->container['home_phone'] = $home_phone;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {


        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


