<?php
/**
 * FundingAccountResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * FundingAccountResponse Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class FundingAccountResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'FundingAccountResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_holder_name' => 'string',
        'nickname' => 'string',
        'address' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO',
        'account_number' => 'string',
        'aba_routing_number' => 'string',
        'issuer_name' => 'string',
        'currency_code3d' => 'string',
        'expiry_date' => 'string',
        'account_holder_type' => 'string',
        'account_subtype' => 'string',
        'id' => 'string',
        'url' => 'string',
        'ach_eligible_flag' => 'string',
        'atm_eligible_flag' => 'string',
        'card_cvv_number' => 'string',
        'account_type' => 'string',
        'status' => 'string',
        'custom_fields' => 'object',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_holder_name' => null,
        'nickname' => null,
        'address' => null,
        'account_number' => null,
        'aba_routing_number' => null,
        'issuer_name' => null,
        'currency_code3d' => null,
        'expiry_date' => null,
        'account_holder_type' => null,
        'account_subtype' => null,
        'id' => null,
        'url' => null,
        'ach_eligible_flag' => null,
        'atm_eligible_flag' => null,
        'card_cvv_number' => null,
        'account_type' => null,
        'status' => null,
        'custom_fields' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_holder_name' => 'account_holder_name',
        'nickname' => 'nickname',
        'address' => 'address',
        'account_number' => 'account_number',
        'aba_routing_number' => 'aba_routing_number',
        'issuer_name' => 'issuer_name',
        'currency_code3d' => 'currency_code3d',
        'expiry_date' => 'expiry_date',
        'account_holder_type' => 'account_holder_type',
        'account_subtype' => 'account_subtype',
        'id' => 'id',
        'url' => 'url',
        'ach_eligible_flag' => 'ach_eligible_flag',
        'atm_eligible_flag' => 'atm_eligible_flag',
        'card_cvv_number' => 'card_cvv_number',
        'account_type' => 'account_type',
        'status' => 'status',
        'custom_fields' => 'custom_fields',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_holder_name' => 'setAccountHolderName',
        'nickname' => 'setNickname',
        'address' => 'setAddress',
        'account_number' => 'setAccountNumber',
        'aba_routing_number' => 'setAbaRoutingNumber',
        'issuer_name' => 'setIssuerName',
        'currency_code3d' => 'setCurrencyCode3d',
        'expiry_date' => 'setExpiryDate',
        'account_holder_type' => 'setAccountHolderType',
        'account_subtype' => 'setAccountSubtype',
        'id' => 'setId',
        'url' => 'setUrl',
        'ach_eligible_flag' => 'setAchEligibleFlag',
        'atm_eligible_flag' => 'setAtmEligibleFlag',
        'card_cvv_number' => 'setCardCvvNumber',
        'account_type' => 'setAccountType',
        'status' => 'setStatus',
        'custom_fields' => 'setCustomFields',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_holder_name' => 'getAccountHolderName',
        'nickname' => 'getNickname',
        'address' => 'getAddress',
        'account_number' => 'getAccountNumber',
        'aba_routing_number' => 'getAbaRoutingNumber',
        'issuer_name' => 'getIssuerName',
        'currency_code3d' => 'getCurrencyCode3d',
        'expiry_date' => 'getExpiryDate',
        'account_holder_type' => 'getAccountHolderType',
        'account_subtype' => 'getAccountSubtype',
        'id' => 'getId',
        'url' => 'getUrl',
        'ach_eligible_flag' => 'getAchEligibleFlag',
        'atm_eligible_flag' => 'getAtmEligibleFlag',
        'card_cvv_number' => 'getCardCvvNumber',
        'account_type' => 'getAccountType',
        'status' => 'getStatus',
        'custom_fields' => 'getCustomFields',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const ACCOUNT_HOLDER_TYPE_PERSONAL = 'personal';
    const ACCOUNT_HOLDER_TYPE_BUSINESS = 'business';
    const ACCOUNT_SUBTYPE_SAVINGS = 'savings';
    const ACCOUNT_SUBTYPE_CHECKING = 'checking';
    const ACCOUNT_SUBTYPE_MONEY_MARKET = 'money_market';
    const ACCOUNT_SUBTYPE_VISA_CREDIT = 'visa_credit';
    const ACCOUNT_SUBTYPE_MASTERCARD_CREDIT = 'mastercard_credit';
    const ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT = 'american_express_credit';
    const ACCOUNT_SUBTYPE_DISCOVER_CREDIT = 'discover_credit';
    const ACCOUNT_SUBTYPE_VISA_DEBIT = 'visa_debit';
    const ACCOUNT_SUBTYPE_MASTERCARD_DEBIT = 'mastercard_debit';
    const ACCOUNT_SUBTYPE_DISCOVER_DEBIT = 'discover_debit';
    const ACH_ELIGIBLE_FLAG_YES = 'yes';
    const ACH_ELIGIBLE_FLAG_NO = 'no';
    const ATM_ELIGIBLE_FLAG_YES = 'yes';
    const ATM_ELIGIBLE_FLAG_NO = 'no';
    const ACCOUNT_TYPE_BANK = 'bank';
    const ACCOUNT_TYPE_DEBIT_CARD = 'debit_card';
    const ACCOUNT_TYPE_CREDIT_CARD = 'credit_card';
    const STATUS_ACTIVE = 'active';
    const STATUS_INACTIVE = 'inactive';
    const STATUS_FROZEN = 'frozen';
    const STATUS_DELETED = 'deleted';
    const STATUS_SUSPENDED = 'suspended';
    const STATUS_UNVERIFIED = 'unverified';
    const STATUS_UNUSABLE = 'unusable';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountHolderTypeAllowableValues()
    {
        return [
            self::ACCOUNT_HOLDER_TYPE_PERSONAL,
            self::ACCOUNT_HOLDER_TYPE_BUSINESS,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountSubtypeAllowableValues()
    {
        return [
            self::ACCOUNT_SUBTYPE_SAVINGS,
            self::ACCOUNT_SUBTYPE_CHECKING,
            self::ACCOUNT_SUBTYPE_MONEY_MARKET,
            self::ACCOUNT_SUBTYPE_VISA_CREDIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_CREDIT,
            self::ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_CREDIT,
            self::ACCOUNT_SUBTYPE_VISA_DEBIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_DEBIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_DEBIT,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAchEligibleFlagAllowableValues()
    {
        return [
            self::ACH_ELIGIBLE_FLAG_YES,
            self::ACH_ELIGIBLE_FLAG_NO,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAtmEligibleFlagAllowableValues()
    {
        return [
            self::ATM_ELIGIBLE_FLAG_YES,
            self::ATM_ELIGIBLE_FLAG_NO,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountTypeAllowableValues()
    {
        return [
            self::ACCOUNT_TYPE_BANK,
            self::ACCOUNT_TYPE_DEBIT_CARD,
            self::ACCOUNT_TYPE_CREDIT_CARD,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_ACTIVE,
            self::STATUS_INACTIVE,
            self::STATUS_FROZEN,
            self::STATUS_DELETED,
            self::STATUS_SUSPENDED,
            self::STATUS_UNVERIFIED,
            self::STATUS_UNUSABLE,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['account_holder_name'] = isset($data['account_holder_name']) ? $data['account_holder_name'] : null;
        $this->container['nickname'] = isset($data['nickname']) ? $data['nickname'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
        $this->container['account_number'] = isset($data['account_number']) ? $data['account_number'] : null;
        $this->container['aba_routing_number'] = isset($data['aba_routing_number']) ? $data['aba_routing_number'] : null;
        $this->container['issuer_name'] = isset($data['issuer_name']) ? $data['issuer_name'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['expiry_date'] = isset($data['expiry_date']) ? $data['expiry_date'] : null;
        $this->container['account_holder_type'] = isset($data['account_holder_type']) ? $data['account_holder_type'] : null;
        $this->container['account_subtype'] = isset($data['account_subtype']) ? $data['account_subtype'] : null;
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['ach_eligible_flag'] = isset($data['ach_eligible_flag']) ? $data['ach_eligible_flag'] : null;
        $this->container['atm_eligible_flag'] = isset($data['atm_eligible_flag']) ? $data['atm_eligible_flag'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['account_type'] = isset($data['account_type']) ? $data['account_type'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['account_holder_name']) && (strlen($this->container['account_holder_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'account_holder_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['account_holder_name']) && (strlen($this->container['account_holder_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'account_holder_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['account_holder_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['account_holder_name'])) {
            $invalidProperties[] = "invalid value for 'account_holder_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['nickname']) && (strlen($this->container['nickname']) > 32)) {
            $invalidProperties[] = "invalid value for 'nickname', the character length must be smaller than or equal to 32.";
        }

        if (!is_null($this->container['nickname']) && (strlen($this->container['nickname']) < 0)) {
            $invalidProperties[] = "invalid value for 'nickname', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['nickname']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['nickname'])) {
            $invalidProperties[] = "invalid value for 'nickname', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['account_number']) && (strlen($this->container['account_number']) > 32)) {
            $invalidProperties[] = "invalid value for 'account_number', the character length must be smaller than or equal to 32.";
        }

        if (!is_null($this->container['account_number']) && (strlen($this->container['account_number']) < 4)) {
            $invalidProperties[] = "invalid value for 'account_number', the character length must be bigger than or equal to 4.";
        }

        if (!is_null($this->container['account_number']) && !preg_match("/[a-zA-Z0-9]+/", $this->container['account_number'])) {
            $invalidProperties[] = "invalid value for 'account_number', must be conform to the pattern /[a-zA-Z0-9]+/.";
        }

        if (!is_null($this->container['aba_routing_number']) && (strlen($this->container['aba_routing_number']) > 9)) {
            $invalidProperties[] = "invalid value for 'aba_routing_number', the character length must be smaller than or equal to 9.";
        }

        if (!is_null($this->container['aba_routing_number']) && (strlen($this->container['aba_routing_number']) < 9)) {
            $invalidProperties[] = "invalid value for 'aba_routing_number', the character length must be bigger than or equal to 9.";
        }

        if (!is_null($this->container['aba_routing_number']) && !preg_match("/[0-9]{9}/", $this->container['aba_routing_number'])) {
            $invalidProperties[] = "invalid value for 'aba_routing_number', must be conform to the pattern /[0-9]{9}/.";
        }

        if (!is_null($this->container['issuer_name']) && (strlen($this->container['issuer_name']) > 32)) {
            $invalidProperties[] = "invalid value for 'issuer_name', the character length must be smaller than or equal to 32.";
        }

        if (!is_null($this->container['issuer_name']) && (strlen($this->container['issuer_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'issuer_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['issuer_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['issuer_name'])) {
            $invalidProperties[] = "invalid value for 'issuer_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['currency_code3d']) && (strlen($this->container['currency_code3d']) > 3)) {
            $invalidProperties[] = "invalid value for 'currency_code3d', the character length must be smaller than or equal to 3.";
        }

        if (!is_null($this->container['currency_code3d']) && (strlen($this->container['currency_code3d']) < 3)) {
            $invalidProperties[] = "invalid value for 'currency_code3d', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['currency_code3d']) && !preg_match("/[A-Z]{3}/", $this->container['currency_code3d'])) {
            $invalidProperties[] = "invalid value for 'currency_code3d', must be conform to the pattern /[A-Z]{3}/.";
        }

        if (!is_null($this->container['expiry_date']) && (strlen($this->container['expiry_date']) > 5)) {
            $invalidProperties[] = "invalid value for 'expiry_date', the character length must be smaller than or equal to 5.";
        }

        if (!is_null($this->container['expiry_date']) && (strlen($this->container['expiry_date']) < 5)) {
            $invalidProperties[] = "invalid value for 'expiry_date', the character length must be bigger than or equal to 5.";
        }

        if (!is_null($this->container['expiry_date']) && !preg_match("/[0-9]{2}\/[0-9]{2}/", $this->container['expiry_date'])) {
            $invalidProperties[] = "invalid value for 'expiry_date', must be conform to the pattern /[0-9]{2}\/[0-9]{2}/.";
        }

        $allowedValues = $this->getAccountHolderTypeAllowableValues();
        if (!in_array($this->container['account_holder_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'account_holder_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getAccountSubtypeAllowableValues();
        if (!in_array($this->container['account_subtype'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'account_subtype', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['id']) && (strlen($this->container['id']) > 20)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['id']) && (strlen($this->container['id']) < 0)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['id']) && !preg_match("/[0-9]{1,20}/", $this->container['id'])) {
            $invalidProperties[] = "invalid value for 'id', must be conform to the pattern /[0-9]{1,20}/.";
        }

        $allowedValues = $this->getAchEligibleFlagAllowableValues();
        if (!in_array($this->container['ach_eligible_flag'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'ach_eligible_flag', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getAtmEligibleFlagAllowableValues();
        if (!in_array($this->container['atm_eligible_flag'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'atm_eligible_flag', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) > 4)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be smaller than or equal to 4.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) < 3)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['card_cvv_number']) && !preg_match("/[0-9]+/", $this->container['card_cvv_number'])) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', must be conform to the pattern /[0-9]+/.";
        }

        $allowedValues = $this->getAccountTypeAllowableValues();
        if (!in_array($this->container['account_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'account_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'status', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['account_holder_name']) > 60) {
            return false;
        }
        if (strlen($this->container['account_holder_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['account_holder_name'])) {
            return false;
        }
        if (strlen($this->container['nickname']) > 32) {
            return false;
        }
        if (strlen($this->container['nickname']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['nickname'])) {
            return false;
        }
        if (strlen($this->container['account_number']) > 32) {
            return false;
        }
        if (strlen($this->container['account_number']) < 4) {
            return false;
        }
        if (!preg_match("/[a-zA-Z0-9]+/", $this->container['account_number'])) {
            return false;
        }
        if (strlen($this->container['aba_routing_number']) > 9) {
            return false;
        }
        if (strlen($this->container['aba_routing_number']) < 9) {
            return false;
        }
        if (!preg_match("/[0-9]{9}/", $this->container['aba_routing_number'])) {
            return false;
        }
        if (strlen($this->container['issuer_name']) > 32) {
            return false;
        }
        if (strlen($this->container['issuer_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['issuer_name'])) {
            return false;
        }
        if (strlen($this->container['currency_code3d']) > 3) {
            return false;
        }
        if (strlen($this->container['currency_code3d']) < 3) {
            return false;
        }
        if (!preg_match("/[A-Z]{3}/", $this->container['currency_code3d'])) {
            return false;
        }
        if (strlen($this->container['expiry_date']) > 5) {
            return false;
        }
        if (strlen($this->container['expiry_date']) < 5) {
            return false;
        }
        if (!preg_match("/[0-9]{2}\/[0-9]{2}/", $this->container['expiry_date'])) {
            return false;
        }
        $allowedValues = $this->getAccountHolderTypeAllowableValues();
        if (!in_array($this->container['account_holder_type'], $allowedValues)) {
            return false;
        }
        $allowedValues = $this->getAccountSubtypeAllowableValues();
        if (!in_array($this->container['account_subtype'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['id']) > 20) {
            return false;
        }
        if (strlen($this->container['id']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9]{1,20}/", $this->container['id'])) {
            return false;
        }
        $allowedValues = $this->getAchEligibleFlagAllowableValues();
        if (!in_array($this->container['ach_eligible_flag'], $allowedValues)) {
            return false;
        }
        $allowedValues = $this->getAtmEligibleFlagAllowableValues();
        if (!in_array($this->container['atm_eligible_flag'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) > 4) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) < 3) {
            return false;
        }
        if (!preg_match("/[0-9]+/", $this->container['card_cvv_number'])) {
            return false;
        }
        $allowedValues = $this->getAccountTypeAllowableValues();
        if (!in_array($this->container['account_type'], $allowedValues)) {
            return false;
        }
        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            return false;
        }
        return true;
    }


    /**
     * Gets account_holder_name
     *
     * @return string
     */
    public function getAccountHolderName()
    {
        return $this->container['account_holder_name'];
    }

    /**
     * Sets account_holder_name
     *
     * @param string $account_holder_name The name as specified on the account.
     *
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->container['account_holder_name'] = $account_holder_name;

        return $this;
    }

    /**
     * Gets nickname
     *
     * @return string
     */
    public function getNickname()
    {
        return $this->container['nickname'];
    }

    /**
     * Sets nickname
     *
     * @param string $nickname The nickname by which a customer might want to identify the account.
     *
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->container['nickname'] = $nickname;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets account_number
     *
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->container['account_number'];
    }

    /**
     * Sets account_number
     *
     * @param string $account_number The number or reference that a customer uses to identify the funding account.
     *
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->container['account_number'] = $account_number;

        return $this;
    }

    /**
     * Gets aba_routing_number
     *
     * @return string
     */
    public function getAbaRoutingNumber()
    {
        return $this->container['aba_routing_number'];
    }

    /**
     * Sets aba_routing_number
     *
     * @param string $aba_routing_number The ABA/Routing number for the bank account.
     *
     * @return $this
     */
    public function setAbaRoutingNumber($aba_routing_number)
    {
        $this->container['aba_routing_number'] = $aba_routing_number;

        return $this;
    }

    /**
     * Gets issuer_name
     *
     * @return string
     */
    public function getIssuerName()
    {
        return $this->container['issuer_name'];
    }

    /**
     * Sets issuer_name
     *
     * @param string $issuer_name The name of the authority that has issued the account. This is relevant only in the case of bank accounts.
     *
     * @return $this
     */
    public function setIssuerName($issuer_name)
    {
        $this->container['issuer_name'] = $issuer_name;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets expiry_date
     *
     * @return string
     */
    public function getExpiryDate()
    {
        return $this->container['expiry_date'];
    }

    /**
     * Sets expiry_date
     *
     * @param string $expiry_date The expiry date for the card. This is to be in the format MM/yy. Only applicable for cards accounts.
     *
     * @return $this
     */
    public function setExpiryDate($expiry_date)
    {
        $this->container['expiry_date'] = $expiry_date;

        return $this;
    }

    /**
     * Gets account_holder_type
     *
     * @return string
     */
    public function getAccountHolderType()
    {
        return $this->container['account_holder_type'];
    }

    /**
     * Sets account_holder_type
     *
     * @param string $account_holder_type The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.
     *
     * @return $this
     */
    public function setAccountHolderType($account_holder_type)
    {
        $this->container['account_holder_type'] = $account_holder_type;

        return $this;
    }

    /**
     * Gets account_subtype
     *
     * @return string
     */
    public function getAccountSubtype()
    {
        return $this->container['account_subtype'];
    }

    /**
     * Sets account_subtype
     *
     * @param string $account_subtype The sub type of the funding account. This is derived by Orbipay in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account. For e.g., a savings account, a checking account.
     *
     * @return $this
     */
    public function setAccountSubtype($account_subtype)
    {
        $this->container['account_subtype'] = $account_subtype;

        return $this;
    }

    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id Id is a unique identifier assigned to the funding account in Orbipay.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the Account details.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets ach_eligible_flag
     *
     * @return string
     */
    public function getAchEligibleFlag()
    {
        return $this->container['ach_eligible_flag'];
    }

    /**
     * Sets ach_eligible_flag
     *
     * @param string $ach_eligible_flag Indicates if the funding account can be debited vide ACH, in case the funding account is a Demand Deposit Account (DDA).
     *
     * @return $this
     */
    public function setAchEligibleFlag($ach_eligible_flag)
    {
        $this->container['ach_eligible_flag'] = $ach_eligible_flag;

        return $this;
    }

    /**
     * Gets atm_eligible_flag
     *
     * @return string
     */
    public function getAtmEligibleFlag()
    {
        return $this->container['atm_eligible_flag'];
    }

    /**
     * Sets atm_eligible_flag
     *
     * @param string $atm_eligible_flag Indicates if the funding account can be debited vide the ATM Rail network, in case the funding account is a Debit Card.
     *
     * @return $this
     */
    public function setAtmEligibleFlag($atm_eligible_flag)
    {
        $this->container['atm_eligible_flag'] = $atm_eligible_flag;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when adding or editing a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets account_type
     *
     * @return string
     */
    public function getAccountType()
    {
        return $this->container['account_type'];
    }

    /**
     * Sets account_type
     *
     * @param string $account_type The type of the funding account.
     *
     * @return $this
     */
    public function setAccountType($account_type)
    {
        $this->container['account_type'] = $account_type;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the funding account in Orbipay.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets custom_fields
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     * @param object $custom_fields
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets auditInfo
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets auditInfo
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo $auditInfo AuditInfo
     *
     * @return $this
     */
    public function setAuditInfo($auditInfo)
    {
        $this->container['audit_info'] = $auditInfo;

        return $this;
    }

    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {


        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


