<?php
/**
 * PaymentNetworkResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.6
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * PaymentNetworkResponse Class Doc Comment
 *
 * @category Class
 * @description The response received either from ACH or Card networks.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PaymentNetworkResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PaymentNetworkResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_auth_code' => 'string',
        'payment_response_code' => 'string',
        'payment_response_msg' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_auth_code' => null,
        'payment_response_code' => null,
        'payment_response_msg' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_auth_code' => 'payment_auth_code',
        'payment_response_code' => 'payment_response_code',
        'payment_response_msg' => 'payment_response_msg'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_auth_code' => 'setPaymentAuthCode',
        'payment_response_code' => 'setPaymentResponseCode',
        'payment_response_msg' => 'setPaymentResponseMsg'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_auth_code' => 'getPaymentAuthCode',
        'payment_response_code' => 'getPaymentResponseCode',
        'payment_response_msg' => 'getPaymentResponseMsg'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['payment_auth_code'] = isset($data['payment_auth_code']) ? $data['payment_auth_code'] : null;
        $this->container['payment_response_code'] = isset($data['payment_response_code']) ? $data['payment_response_code'] : null;
        $this->container['payment_response_msg'] = isset($data['payment_response_msg']) ? $data['payment_response_msg'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets payment_auth_code
     *
     * @return string
     */
    public function getPaymentAuthCode()
    {
        return $this->container['payment_auth_code'];
    }

    /**
     * Sets payment_auth_code
     *
     * @param string $payment_auth_code The Auth Code returned by the card gateway. This is relevant only for card payments.
     *
     * @return $this
     */
    public function setPaymentAuthCode($payment_auth_code)
    {
        $this->container['payment_auth_code'] = $payment_auth_code;

        return $this;
    }

    /**
     * Gets payment_response_code
     *
     * @return string
     */
    public function getPaymentResponseCode()
    {
        return $this->container['payment_response_code'];
    }

    /**
     * Sets payment_response_code
     *
     * @param string $payment_response_code The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments. OR The decline codes received from the card issuer or the card processor, in the event of declined card payments.
     *
     * @return $this
     */
    public function setPaymentResponseCode($payment_response_code)
    {
        $this->container['payment_response_code'] = $payment_response_code;

        return $this;
    }

    /**
     * Gets payment_response_msg
     *
     * @return string
     */
    public function getPaymentResponseMsg()
    {
        return $this->container['payment_response_msg'];
    }

    /**
     * Sets payment_response_msg
     *
     * @param string $payment_response_msg The text describing the ACH return or the chargeback received from Visa/Mastercard, in the event of returned payments. OR The text describing the decline, from the card issuer or the card processor, in the event of declined card payments.
     *
     * @return $this
     */
    public function setPaymentResponseMsg($payment_response_msg)
    {
        $this->container['payment_response_msg'] = $payment_response_msg;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


