<?php
/**
 * PaymentResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * PaymentResponse Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PaymentResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PaymentResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FeeResponse',
        'status' => 'string',
        'payment_method' => 'string',
        'confirmation_number' => 'string',
        'currency_code3d' => 'string',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'payment_date' => 'string',
        'payment_schedule_type' => 'string',
        'transaction_type' => 'string',
        'payment_request_date' => 'string',
        'payment_amount_type' => 'string',
        'payment_reference' => 'string',
        'expected_payment_settlement_date' => 'string',
        'payment_entry_date' => 'string',
        'payment_return_date' => 'string',
        'return_code' => 'string',
        'customer' => '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerSnapshotResponse',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountSnapshotResponse',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountSnapshotResponse',
        'custom_fields' => 'object',
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'confirmation_number' => null,
        'currency_code3d' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'payment_date' => null,
        'payment_schedule_type' => null,
        'transaction_type' => null,
        'payment_request_date' => null,
        'payment_amount_type' => null,
        'payment_reference' => null,
        'expected_payment_settlement_date' => null,
        'payment_entry_date' => null,
        'payment_return_date' => null,
        'return_code' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'custom_fields' => null,
        'payment_network_response' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'confirmation_number' => 'confirmation_number',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'payment_date' => 'payment_date',
        'payment_schedule_type' => 'payment_schedule_type',
        'transaction_type' => 'transaction_type',
        'payment_request_date' => 'payment_request_date',
        'payment_amount_type' => 'payment_amount_type',
        'payment_reference' => 'payment_reference',
        'expected_payment_settlement_date' => 'expected_payment_settlement_date',
        'payment_entry_date' => 'payment_entry_date',
        'payment_return_date' => 'payment_return_date',
        'return_code' => 'return_code',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'custom_fields' => 'custom_fields',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'confirmation_number' => 'setConfirmationNumber',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'payment_date' => 'setPaymentDate',
        'payment_schedule_type' => 'setPaymentScheduleType',
        'transaction_type' => 'setTransactionType',
        'payment_request_date' => 'setPaymentRequestDate',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_reference' => 'setPaymentReference',
        'expected_payment_settlement_date' => 'setExpectedPaymentSettlementDate',
        'payment_entry_date' => 'setPaymentEntryDate',
        'payment_return_date' => 'setPaymentReturnDate',
        'return_code' => 'setReturnCode',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'custom_fields' => 'setCustomFields',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'confirmation_number' => 'getConfirmationNumber',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'payment_date' => 'getPaymentDate',
        'payment_schedule_type' => 'getPaymentScheduleType',
        'transaction_type' => 'getTransactionType',
        'payment_request_date' => 'getPaymentRequestDate',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_reference' => 'getPaymentReference',
        'expected_payment_settlement_date' => 'getExpectedPaymentSettlementDate',
        'payment_entry_date' => 'getPaymentEntryDate',
        'payment_return_date' => 'getPaymentReturnDate',
        'return_code' => 'getReturnCode',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'custom_fields' => 'getCustomFields',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const STATUS_SCHEDULED = 'scheduled';
    const STATUS_CANCELLED = 'cancelled';
    const STATUS_PROCESSING = 'processing';
    const STATUS_PROCESSED = 'processed';
    const STATUS_RETURNED = 'returned';
    const STATUS_DECLINED = 'declined';
    const STATUS_DISPUTED = 'disputed';
    const STATUS_REFUNDED = 'refunded';
    const PAYMENT_METHOD_ACH = 'ach';
    const PAYMENT_METHOD_CHECK = 'check';
    const PAYMENT_METHOD_VISA_DEBIT = 'visa_debit';
    const PAYMENT_METHOD_PINLESS_DEBIT = 'pinless_debit';
    const PAYMENT_METHOD_MASTER_DEBIT = 'master_debit';
    const PAYMENT_METHOD_AMEX_CREDIT = 'amex_credit';
    const PAYMENT_METHOD_DISCOVER_CREDIT = 'discover_credit';
    const PAYMENT_METHOD_VISA_CREDIT = 'visa_credit';
    const PAYMENT_METHOD_MASTER_CREDIT = 'master_credit';
    const PAYMENT_METHOD_CASH = 'cash';
    const PAYMENT_METHOD_DISCOVER_DEBIT = 'discover_debit';
    const PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT = 'one_time_payment';
    const PAYMENT_SCHEDULE_TYPE_AUTOPAY_GENERATED_PAYMENT = 'autopay_generated_payment';
    const PAYMENT_SCHEDULE_TYPE_VARIABLE_RECURRING_GENERATED_PAYMENT = 'variable_recurring_generated_payment';
    const PAYMENT_SCHEDULE_TYPE_PAYMENT_PLAN_GENERATED = 'payment_plan_generated';
    const TRANSACTION_TYPE_SKIP_A_PAYMENT = 'skip_a_payment';
    const TRANSACTION_TYPE_BALANCE_RELOAD = 'balance_reload';
    const TRANSACTION_TYPE_INVOICE_PAYMENT = 'invoice_payment';
    const TRANSACTION_TYPE_CONSOLIDATED_PAYMENT = 'consolidated_payment';
    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT = 'discounted_amount';
    const PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT = 'penalty_amount';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_SCHEDULED,
            self::STATUS_CANCELLED,
            self::STATUS_PROCESSING,
            self::STATUS_PROCESSED,
            self::STATUS_RETURNED,
            self::STATUS_DECLINED,
            self::STATUS_DISPUTED,
            self::STATUS_REFUNDED,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentMethodAllowableValues()
    {
        return [
            self::PAYMENT_METHOD_ACH,
            self::PAYMENT_METHOD_CHECK,
            self::PAYMENT_METHOD_VISA_DEBIT,
            self::PAYMENT_METHOD_PINLESS_DEBIT,
            self::PAYMENT_METHOD_MASTER_DEBIT,
            self::PAYMENT_METHOD_AMEX_CREDIT,
            self::PAYMENT_METHOD_DISCOVER_CREDIT,
            self::PAYMENT_METHOD_VISA_CREDIT,
            self::PAYMENT_METHOD_MASTER_CREDIT,
            self::PAYMENT_METHOD_CASH,
            self::PAYMENT_METHOD_DISCOVER_DEBIT,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_AUTOPAY_GENERATED_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_VARIABLE_RECURRING_GENERATED_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_PAYMENT_PLAN_GENERATED,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getTransactionTypeAllowableValues()
    {
        return [
            self::TRANSACTION_TYPE_SKIP_A_PAYMENT,
            self::TRANSACTION_TYPE_BALANCE_RELOAD,
            self::TRANSACTION_TYPE_INVOICE_PAYMENT,
            self::TRANSACTION_TYPE_CONSOLIDATED_PAYMENT,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['payment_method'] = isset($data['payment_method']) ? $data['payment_method'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['payment_date'] = isset($data['payment_date']) ? $data['payment_date'] : null;
        $this->container['payment_schedule_type'] = isset($data['payment_schedule_type']) ? $data['payment_schedule_type'] : null;
        $this->container['transaction_type'] = isset($data['transaction_type']) ? $data['transaction_type'] : null;
        $this->container['payment_request_date'] = isset($data['payment_request_date']) ? $data['payment_request_date'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['payment_reference'] = isset($data['payment_reference']) ? $data['payment_reference'] : null;
        $this->container['expected_payment_settlement_date'] = isset($data['expected_payment_settlement_date']) ? $data['expected_payment_settlement_date'] : null;
        $this->container['payment_entry_date'] = isset($data['payment_entry_date']) ? $data['payment_entry_date'] : null;
        $this->container['payment_return_date'] = isset($data['payment_return_date']) ? $data['payment_return_date'] : null;
        $this->container['return_code'] = isset($data['return_code']) ? $data['return_code'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['payment_network_response'] = isset($data['payment_network_response']) ? $data['payment_network_response'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['id']) && (strlen($this->container['id']) > 20)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['id']) && (strlen($this->container['id']) < 0)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['id']) && !preg_match("/[0-9]{1,20}/", $this->container['id'])) {
            $invalidProperties[] = "invalid value for 'id', must be conform to the pattern /[0-9]{1,20}/.";
        }

        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'status', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getPaymentMethodAllowableValues();
        if (!in_array($this->container['payment_method'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_method', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['confirmation_number']) && (strlen($this->container['confirmation_number']) > 30)) {
            $invalidProperties[] = "invalid value for 'confirmation_number', the character length must be smaller than or equal to 30.";
        }

        if (!is_null($this->container['confirmation_number']) && (strlen($this->container['confirmation_number']) < 0)) {
            $invalidProperties[] = "invalid value for 'confirmation_number', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['confirmation_number']) && !preg_match("/[a-zA-Z0-9]+/", $this->container['confirmation_number'])) {
            $invalidProperties[] = "invalid value for 'confirmation_number', must be conform to the pattern /[a-zA-Z0-9]+/.";
        }

        if (!is_null($this->container['currency_code3d']) && (strlen($this->container['currency_code3d']) > 3)) {
            $invalidProperties[] = "invalid value for 'currency_code3d', the character length must be smaller than or equal to 3.";
        }

        if (!is_null($this->container['currency_code3d']) && (strlen($this->container['currency_code3d']) < 3)) {
            $invalidProperties[] = "invalid value for 'currency_code3d', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['currency_code3d']) && !preg_match("/[A-Z]{3}/", $this->container['currency_code3d'])) {
            $invalidProperties[] = "invalid value for 'currency_code3d', must be conform to the pattern /[A-Z]{3}/.";
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) > 17)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be smaller than or equal to 17.";
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) < 1)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['amount']) && !preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            $invalidProperties[] = "invalid value for 'amount', must be conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) > 4)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be smaller than or equal to 4.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) < 3)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['card_cvv_number']) && !preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', must be conform to the pattern /[0-9]{3,4}/.";
        }

        if (!is_null($this->container['payment_date']) && (strlen($this->container['payment_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_date']) && (strlen($this->container['payment_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_date', the character length must be bigger than or equal to 10.";
        }

        $allowedValues = $this->getPaymentScheduleTypeAllowableValues();
        if (!in_array($this->container['payment_schedule_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_schedule_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getTransactionTypeAllowableValues();
        if (!in_array($this->container['transaction_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'transaction_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['payment_request_date']) && (strlen($this->container['payment_request_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_request_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_request_date']) && (strlen($this->container['payment_request_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_request_date', the character length must be bigger than or equal to 10.";
        }

        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_amount_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['payment_reference']) && (strlen($this->container['payment_reference']) > 50)) {
            $invalidProperties[] = "invalid value for 'payment_reference', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['payment_reference']) && (strlen($this->container['payment_reference']) < 0)) {
            $invalidProperties[] = "invalid value for 'payment_reference', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['payment_reference']) && !preg_match("/[0-9a-zA-Z._-]{0,50}/", $this->container['payment_reference'])) {
            $invalidProperties[] = "invalid value for 'payment_reference', must be conform to the pattern /[0-9a-zA-Z._-]{0,50}/.";
        }

        if (!is_null($this->container['expected_payment_settlement_date']) && (strlen($this->container['expected_payment_settlement_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'expected_payment_settlement_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['expected_payment_settlement_date']) && (strlen($this->container['expected_payment_settlement_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'expected_payment_settlement_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['payment_entry_date']) && (strlen($this->container['payment_entry_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_entry_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_entry_date']) && (strlen($this->container['payment_entry_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_entry_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['payment_return_date']) && (strlen($this->container['payment_return_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_return_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_return_date']) && (strlen($this->container['payment_return_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_return_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['return_code']) && (strlen($this->container['return_code']) > 10)) {
            $invalidProperties[] = "invalid value for 'return_code', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['return_code']) && (strlen($this->container['return_code']) < 0)) {
            $invalidProperties[] = "invalid value for 'return_code', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['return_code']) && !preg_match("/[a-z0-9]{0,10}/", $this->container['return_code'])) {
            $invalidProperties[] = "invalid value for 'return_code', must be conform to the pattern /[a-z0-9]{0,10}/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['id']) > 20) {
            return false;
        }
        if (strlen($this->container['id']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9]{1,20}/", $this->container['id'])) {
            return false;
        }
        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            return false;
        }
        $allowedValues = $this->getPaymentMethodAllowableValues();
        if (!in_array($this->container['payment_method'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['confirmation_number']) > 30) {
            return false;
        }
        if (strlen($this->container['confirmation_number']) < 0) {
            return false;
        }
        if (!preg_match("/[a-zA-Z0-9]+/", $this->container['confirmation_number'])) {
            return false;
        }
        if (strlen($this->container['currency_code3d']) > 3) {
            return false;
        }
        if (strlen($this->container['currency_code3d']) < 3) {
            return false;
        }
        if (!preg_match("/[A-Z]{3}/", $this->container['currency_code3d'])) {
            return false;
        }
        if (strlen($this->container['amount']) > 17) {
            return false;
        }
        if (strlen($this->container['amount']) < 1) {
            return false;
        }
        if (!preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) > 4) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) < 3) {
            return false;
        }
        if (!preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            return false;
        }
        if (strlen($this->container['payment_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_date']) < 10) {
            return false;
        }
        $allowedValues = $this->getPaymentScheduleTypeAllowableValues();
        if (!in_array($this->container['payment_schedule_type'], $allowedValues)) {
            return false;
        }
        $allowedValues = $this->getTransactionTypeAllowableValues();
        if (!in_array($this->container['transaction_type'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['payment_request_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_request_date']) < 10) {
            return false;
        }
        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['payment_reference']) > 50) {
            return false;
        }
        if (strlen($this->container['payment_reference']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z._-]{0,50}/", $this->container['payment_reference'])) {
            return false;
        }
        if (strlen($this->container['expected_payment_settlement_date']) > 10) {
            return false;
        }
        if (strlen($this->container['expected_payment_settlement_date']) < 10) {
            return false;
        }
        if (strlen($this->container['payment_entry_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_entry_date']) < 10) {
            return false;
        }
        if (strlen($this->container['payment_return_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_return_date']) < 10) {
            return false;
        }
        if (strlen($this->container['return_code']) > 10) {
            return false;
        }
        if (strlen($this->container['return_code']) < 0) {
            return false;
        }
        if (!preg_match("/[a-z0-9]{0,10}/", $this->container['return_code'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by Orbipay to the payment.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of payment.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FeeResponse
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FeeResponse $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the payment.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return string
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param string $payment_method The fulfillment method for the payment.
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets payment_date
     *
     * @return string
     */
    public function getPaymentDate()
    {
        return $this->container['payment_date'];
    }

    /**
     * Sets payment_date
     *
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->container['payment_date'] = $payment_date;

        return $this;
    }

    /**
     * Gets payment_schedule_type
     *
     * @return string
     */
    public function getPaymentScheduleType()
    {
        return $this->container['payment_schedule_type'];
    }

    /**
     * Sets payment_schedule_type
     *
     * @param string $payment_schedule_type The schedule type for the payment. This defaults to one_time_payment.
     *
     * @return $this
     */
    public function setPaymentScheduleType($payment_schedule_type)
    {
        $this->container['payment_schedule_type'] = $payment_schedule_type;

        return $this;
    }

    /**
     * Gets transaction_type
     *
     * @return string
     */
    public function getTransactionType()
    {
        return $this->container['transaction_type'];
    }

    /**
     * Sets transaction_type
     *
     * @param string $transaction_type The type of payment transaction.
     *
     * @return $this
     */
    public function setTransactionType($transaction_type)
    {
        $this->container['transaction_type'] = $transaction_type;

        return $this;
    }

    /**
     * Gets payment_request_date
     *
     * @return string
     */
    public function getPaymentRequestDate()
    {
        return $this->container['payment_request_date'];
    }

    /**
     * Sets payment_request_date
     *
     * @param string $payment_request_date The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.
     *
     * @return $this
     */
    public function setPaymentRequestDate($payment_request_date)
    {
        $this->container['payment_request_date'] = $payment_request_date;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets payment_reference
     *
     * @return string
     */
    public function getPaymentReference()
    {
        return $this->container['payment_reference'];
    }

    /**
     * Sets payment_reference
     *
     * @param string $payment_reference The unique identifier in the client system for the payment.
     *
     * @return $this
     */
    public function setPaymentReference($payment_reference)
    {
        $this->container['payment_reference'] = $payment_reference;

        return $this;
    }

    /**
     * Gets expected_payment_settlement_date
     *
     * @return string
     */
    public function getExpectedPaymentSettlementDate()
    {
        return $this->container['expected_payment_settlement_date'];
    }

    /**
     * Sets expected_payment_settlement_date
     *
     * @param string $expected_payment_settlement_date The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setExpectedPaymentSettlementDate($expected_payment_settlement_date)
    {
        $this->container['expected_payment_settlement_date'] = $expected_payment_settlement_date;

        return $this;
    }

    /**
     * Gets payment_entry_date
     *
     * @return string
     */
    public function getPaymentEntryDate()
    {
        return $this->container['payment_entry_date'];
    }

    /**
     * Sets payment_entry_date
     *
     * @param string $payment_entry_date The date on which the payment is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentEntryDate($payment_entry_date)
    {
        $this->container['payment_entry_date'] = $payment_entry_date;

        return $this;
    }

    /**
     * Gets payment_return_date
     *
     * @return string
     */
    public function getPaymentReturnDate()
    {
        return $this->container['payment_return_date'];
    }

    /**
     * Sets payment_return_date
     *
     * @param string $payment_return_date The date on which the ACH returns is received by Orbipay.
     *
     * @return $this
     */
    public function setPaymentReturnDate($payment_return_date)
    {
        $this->container['payment_return_date'] = $payment_return_date;

        return $this;
    }

    /**
     * Gets return_code
     *
     * @return string
     */
    public function getReturnCode()
    {
        return $this->container['return_code'];
    }

    /**
     * Sets return_code
     *
     * @param string $return_code The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.
     *
     * @return $this
     */
    public function setReturnCode($return_code)
    {
        $this->container['return_code'] = $return_code;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerSnapshotResponse
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerSnapshotResponse $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountSnapshotResponse
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountSnapshotResponse $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountSnapshotResponse
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\CustomerAccountSnapshotResponse $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets custom_fields
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     * @param object $custom_fields
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse
     */
    public function getPaymentNetworkResponse()
    {
        return $this->container['payment_network_response'];
    }

    /**
     * Sets payment_network_response
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse $payment_network_response payment_network_response
     *
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->container['payment_network_response'] = $payment_network_response;

        return $this;
    }

    /**
     * Gets auditInfo
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets auditInfo
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo $auditInfo AuditInfo
     *
     * @return $this
     */
    public function setAuditInfo($auditInfo)
    {
        $this->container['audit_info'] = $auditInfo;

        return $this;
    }


    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


