<?php
/**
 * PaymentScheduleVO
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * PaymentScheduleVO Class Doc Comment
 *
 * @category Class
 * @description The schedule for the payments that are created as part of a payment setup like recurring payment or autopay.
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PaymentScheduleVO implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PaymentScheduleVO';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_recurring_type' => 'string',
        'payment_recurring_count' => 'string',
        'payment_amount_type' => 'string',
        'payment_start_date' => 'string',
        'payment_end_date' => 'string',
        'payment_limit_amount' => 'string',
        'payment_plan_id' => 'string',
        'payment_defer_days' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_recurring_type' => null,
        'payment_recurring_count' => null,
        'payment_amount_type' => null,
        'payment_start_date' => null,
        'payment_end_date' => null,
        'payment_limit_amount' => null,
        'payment_plan_id' => null,
        'payment_defer_days' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_recurring_type' => 'payment_recurring_type',
        'payment_recurring_count' => 'payment_recurring_count',
        'payment_amount_type' => 'payment_amount_type',
        'payment_start_date' => 'payment_start_date',
        'payment_end_date' => 'payment_end_date',
        'payment_limit_amount' => 'payment_limit_amount',
        'payment_plan_id' => 'payment_plan_id',
        'payment_defer_days' => 'payment_defer_days'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_recurring_type' => 'setPaymentRecurringType',
        'payment_recurring_count' => 'setPaymentRecurringCount',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_start_date' => 'setPaymentStartDate',
        'payment_end_date' => 'setPaymentEndDate',
        'payment_limit_amount' => 'setPaymentLimitAmount',
        'payment_plan_id' => 'setPaymentPlanId',
        'payment_defer_days' => 'setPaymentDeferDays'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_recurring_type' => 'getPaymentRecurringType',
        'payment_recurring_count' => 'getPaymentRecurringCount',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_start_date' => 'getPaymentStartDate',
        'payment_end_date' => 'getPaymentEndDate',
        'payment_limit_amount' => 'getPaymentLimitAmount',
        'payment_plan_id' => 'getPaymentPlanId',
        'payment_defer_days' => 'getPaymentDeferDays'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const PAYMENT_RECURRING_TYPE_DAILY = 'daily';
    const PAYMENT_RECURRING_TYPE_WEEKLY = 'weekly';
    const PAYMENT_RECURRING_TYPE_MONTHLY = 'monthly';
    const PAYMENT_RECURRING_TYPE_BI_MONTHLY = 'bi_monthly';
    const PAYMENT_RECURRING_TYPE_BI_WEEKLY = 'bi_weekly';
    const PAYMENT_RECURRING_TYPE_QUARTERLY = 'quarterly';
    const PAYMENT_RECURRING_TYPE_HALF_YEARLY = 'half_yearly';
    const PAYMENT_RECURRING_TYPE_ANNUAL = 'annual';
    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT = 'discounted_amount';
    const PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT = 'penalty_amount';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentRecurringTypeAllowableValues()
    {
        return [
            self::PAYMENT_RECURRING_TYPE_DAILY,
            self::PAYMENT_RECURRING_TYPE_WEEKLY,
            self::PAYMENT_RECURRING_TYPE_MONTHLY,
            self::PAYMENT_RECURRING_TYPE_BI_MONTHLY,
            self::PAYMENT_RECURRING_TYPE_BI_WEEKLY,
            self::PAYMENT_RECURRING_TYPE_QUARTERLY,
            self::PAYMENT_RECURRING_TYPE_HALF_YEARLY,
            self::PAYMENT_RECURRING_TYPE_ANNUAL,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['payment_recurring_type'] = isset($data['payment_recurring_type']) ? $data['payment_recurring_type'] : null;
        $this->container['payment_recurring_count'] = isset($data['payment_recurring_count']) ? $data['payment_recurring_count'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['payment_start_date'] = isset($data['payment_start_date']) ? $data['payment_start_date'] : null;
        $this->container['payment_end_date'] = isset($data['payment_end_date']) ? $data['payment_end_date'] : null;
        $this->container['payment_limit_amount'] = isset($data['payment_limit_amount']) ? $data['payment_limit_amount'] : null;
        $this->container['payment_plan_id'] = isset($data['payment_plan_id']) ? $data['payment_plan_id'] : null;
        $this->container['payment_defer_days'] = isset($data['payment_defer_days']) ? $data['payment_defer_days'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getPaymentRecurringTypeAllowableValues();
        if (!in_array($this->container['payment_recurring_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_recurring_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['payment_recurring_count']) && (strlen($this->container['payment_recurring_count']) > 3)) {
            $invalidProperties[] = "invalid value for 'payment_recurring_count', the character length must be smaller than or equal to 3.";
        }

        if (!is_null($this->container['payment_recurring_count']) && (strlen($this->container['payment_recurring_count']) < 1)) {
            $invalidProperties[] = "invalid value for 'payment_recurring_count', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['payment_recurring_count']) && !preg_match("/[0-9]+/", $this->container['payment_recurring_count'])) {
            $invalidProperties[] = "invalid value for 'payment_recurring_count', must be conform to the pattern /[0-9]+/.";
        }

        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_amount_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['payment_start_date']) && (strlen($this->container['payment_start_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_start_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_start_date']) && (strlen($this->container['payment_start_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_start_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['payment_end_date']) && (strlen($this->container['payment_end_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_end_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_end_date']) && (strlen($this->container['payment_end_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_end_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['payment_limit_amount']) && (strlen($this->container['payment_limit_amount']) > 17)) {
            $invalidProperties[] = "invalid value for 'payment_limit_amount', the character length must be smaller than or equal to 17.";
        }

        if (!is_null($this->container['payment_limit_amount']) && (strlen($this->container['payment_limit_amount']) < 1)) {
            $invalidProperties[] = "invalid value for 'payment_limit_amount', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['payment_limit_amount']) && !preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['payment_limit_amount'])) {
            $invalidProperties[] = "invalid value for 'payment_limit_amount', must be conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.";
        }

        if (!is_null($this->container['payment_plan_id']) && (strlen($this->container['payment_plan_id']) > 20)) {
            $invalidProperties[] = "invalid value for 'payment_plan_id', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['payment_plan_id']) && !preg_match("/[0-9]{0,9}/", $this->container['payment_plan_id'])) {
            $invalidProperties[] = "invalid value for 'payment_plan_id', must be conform to the pattern /[0-9]{0,9}/.";
        }

        if (!is_null($this->container['payment_defer_days']) && (strlen($this->container['payment_defer_days']) > 2)) {
            $invalidProperties[] = "invalid value for 'payment_defer_days', the character length must be smaller than or equal to 2.";
        }

        if (!is_null($this->container['payment_defer_days']) && (strlen($this->container['payment_defer_days']) < 1)) {
            $invalidProperties[] = "invalid value for 'payment_defer_days', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['payment_defer_days']) && !preg_match("/[0-9]+/", $this->container['payment_defer_days'])) {
            $invalidProperties[] = "invalid value for 'payment_defer_days', must be conform to the pattern /[0-9]+/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        $allowedValues = $this->getPaymentRecurringTypeAllowableValues();
        if (!in_array($this->container['payment_recurring_type'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['payment_recurring_count']) > 3) {
            return false;
        }
        if (strlen($this->container['payment_recurring_count']) < 1) {
            return false;
        }
        if (!preg_match("/[0-9]+/", $this->container['payment_recurring_count'])) {
            return false;
        }
        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['payment_start_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_start_date']) < 10) {
            return false;
        }
        if (strlen($this->container['payment_end_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_end_date']) < 10) {
            return false;
        }
        if (strlen($this->container['payment_limit_amount']) > 17) {
            return false;
        }
        if (strlen($this->container['payment_limit_amount']) < 1) {
            return false;
        }
        if (!preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['payment_limit_amount'])) {
            return false;
        }
        if (strlen($this->container['payment_plan_id']) > 20) {
            return false;
        }
        if (!preg_match("/[0-9]{0,9}/", $this->container['payment_plan_id'])) {
            return false;
        }
        if (strlen($this->container['payment_defer_days']) > 2) {
            return false;
        }
        if (strlen($this->container['payment_defer_days']) < 1) {
            return false;
        }
        if (!preg_match("/[0-9]+/", $this->container['payment_defer_days'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets payment_recurring_type
     *
     * @return string
     */
    public function getPaymentRecurringType()
    {
        return $this->container['payment_recurring_type'];
    }

    /**
     * Sets payment_recurring_type
     *
     * @param string $payment_recurring_type The frequency of the payments created as part of a payment setup. This is applicable only for recurring payment setup, in which case it is mandatory.
     *
     * @return $this
     */
    public function setPaymentRecurringType($payment_recurring_type)
    {
        $this->container['payment_recurring_type'] = $payment_recurring_type;

        return $this;
    }

    /**
     * Gets payment_recurring_count
     *
     * @return string
     */
    public function getPaymentRecurringCount()
    {
        return $this->container['payment_recurring_count'];
    }

    /**
     * Sets payment_recurring_count
     *
     * @param string $payment_recurring_count The maximum number of payments that can be created as part of a recurring payment setup. This cannot be specified for autopay setups.
     *
     * @return $this
     */
    public function setPaymentRecurringCount($payment_recurring_count)
    {
        $this->container['payment_recurring_count'] = $payment_recurring_count;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The amount type that is used to set the amount for payments created as part of a recurring payment or autopay setup. In the case of a recurring payment setup, the payment amount can be specified by the customer. In that case, the payment_amount_type should not be sent as it would default to 'other'. In the case of an autopay setup, the payment amount type is mandatory and it cannot be specified as 'other'. In this case, the payment amount should not be sent.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets payment_start_date
     *
     * @return string
     */
    public function getPaymentStartDate()
    {
        return $this->container['payment_start_date'];
    }

    /**
     * Sets payment_start_date
     *
     * @param string $payment_start_date The date on which the first payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD. This is mandatory for recurring payment setup. This cannot be specified for autopay setups.
     *
     * @return $this
     */
    public function setPaymentStartDate($payment_start_date)
    {
        $this->container['payment_start_date'] = $payment_start_date;

        return $this;
    }

    /**
     * Gets payment_end_date
     *
     * @return string
     */
    public function getPaymentEndDate()
    {
        return $this->container['payment_end_date'];
    }

    /**
     * Sets payment_end_date
     *
     * @param string $payment_end_date The date by which the last payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD. This cannot be specified for autopay setups.
     *
     * @return $this
     */
    public function setPaymentEndDate($payment_end_date)
    {
        $this->container['payment_end_date'] = $payment_end_date;

        return $this;
    }

    /**
     * Gets payment_limit_amount
     *
     * @return string
     */
    public function getPaymentLimitAmount()
    {
        return $this->container['payment_limit_amount'];
    }

    /**
     * Sets payment_limit_amount
     *
     * @param string $payment_limit_amount The upper limit for the payment amount in the case of recurring or autopay payments. Any amount above the limit will not be paid automatically as part of recurring payments and autopay.
     *
     * @return $this
     */
    public function setPaymentLimitAmount($payment_limit_amount)
    {
        $this->container['payment_limit_amount'] = $payment_limit_amount;

        return $this;
    }

    /**
     * Gets payment_plan_id
     *
     * @return string
     */
    public function getPaymentPlanId()
    {
        return $this->container['payment_plan_id'];
    }

    /**
     * Sets payment_plan_id
     *
     * @param string $payment_plan_id The reference to the payment plan, offered by the biller, that is used to set up the recurring payment. The list of payment plans offered is published as part of the biller set-up.
     *
     * @return $this
     */
    public function setPaymentPlanId($payment_plan_id)
    {
        $this->container['payment_plan_id'] = $payment_plan_id;

        return $this;
    }

    /**
     * Gets payment_defer_days
     *
     * @return string
     */
    public function getPaymentDeferDays()
    {
        return $this->container['payment_defer_days'];
    }

    /**
     * Sets payment_defer_days
     *
     * @param string $payment_defer_days The number of days from the bill due date that the customer wishes to delay the autopay payment by. By default an autopay payment is drafted on the bill due date.
     *
     * @return $this
     */
    public function setPaymentDeferDays($payment_defer_days)
    {
        $this->container['payment_defer_days'] = $payment_defer_days;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {


        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


