<?php
/**
 * RefundResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.1
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * RefundResponse Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class RefundResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'RefundResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'refund_reference' => 'string',
        'id' => 'string',
        'url' => 'string',
        'refund_type' => 'string',
        'refund_amount' => 'string',
        'fee_refund' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FeeRefund',
        'status' => 'string',
        'confirmation_number' => 'string',
        'expected_refund_settlement_date' => 'string',
        'refund_date' => 'string',
        'refund_entry_date' => 'string',
        'custom_fields' => 'object',
        'source_payment' => '\Orbipay\PaymentsApi\Client\Swagger\Model\SourcePayment',
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'refund_reference' => null,
        'id' => null,
        'url' => null,
        'refund_type' => null,
        'refund_amount' => null,
        'fee_refund' => null,
        'status' => null,
        'confirmation_number' => null,
        'expected_refund_settlement_date' => 'date',
        'refund_date' => 'date',
        'refund_entry_date' => 'date',
        'custom_fields' => null,
        'source_payment' => null,
        'payment_network_response' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'refund_reference' => 'refund_reference',
        'id' => 'id',
        'url' => 'url',
        'refund_type' => 'refund_type',
        'refund_amount' => 'refund_amount',
        'fee_refund' => 'fee_refund',
        'status' => 'status',
        'confirmation_number' => 'confirmation_number',
        'expected_refund_settlement_date' => 'expected_refund_settlement_date',
        'refund_date' => 'refund_date',
        'refund_entry_date' => 'refund_entry_date',
        'custom_fields' => 'custom_fields',
        'source_payment' => 'source_payment',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'refund_reference' => 'setRefundReference',
        'id' => 'setId',
        'url' => 'setUrl',
        'refund_type' => 'setRefundType',
        'refund_amount' => 'setRefundAmount',
        'fee_refund' => 'setFeeRefund',
        'status' => 'setStatus',
        'confirmation_number' => 'setConfirmationNumber',
        'expected_refund_settlement_date' => 'setExpectedRefundSettlementDate',
        'refund_date' => 'setRefundDate',
        'refund_entry_date' => 'setRefundEntryDate',
        'custom_fields' => 'setCustomFields',
        'source_payment' => 'setSourcePayment',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'refund_reference' => 'getRefundReference',
        'id' => 'getId',
        'url' => 'getUrl',
        'refund_type' => 'getRefundType',
        'refund_amount' => 'getRefundAmount',
        'fee_refund' => 'getFeeRefund',
        'status' => 'getStatus',
        'confirmation_number' => 'getConfirmationNumber',
        'expected_refund_settlement_date' => 'getExpectedRefundSettlementDate',
        'refund_date' => 'getRefundDate',
        'refund_entry_date' => 'getRefundEntryDate',
        'custom_fields' => 'getCustomFields',
        'source_payment' => 'getSourcePayment',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const REFUND_TYPE_PAYMENT_AND_FEE = 'payment_and_fee';
    const REFUND_TYPE_PAYMENT_ONLY = 'payment_only';
    const REFUND_TYPE_FEE_ONLY = 'fee_only';
    const REFUND_TYPE_OTHER = 'other';
    const STATUS_SCHEDULED = 'scheduled';
    const STATUS_PROCESSING = 'processing';
    const STATUS_PROCESSED = 'processed';
    const STATUS_DECLINED = 'declined';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getRefundTypeAllowableValues()
    {
        return [
            self::REFUND_TYPE_PAYMENT_AND_FEE,
            self::REFUND_TYPE_PAYMENT_ONLY,
            self::REFUND_TYPE_FEE_ONLY,
            self::REFUND_TYPE_OTHER,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_SCHEDULED,
            self::STATUS_PROCESSING,
            self::STATUS_PROCESSED,
            self::STATUS_DECLINED,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['refund_reference'] = isset($data['refund_reference']) ? $data['refund_reference'] : null;
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['refund_type'] = isset($data['refund_type']) ? $data['refund_type'] : null;
        $this->container['refund_amount'] = isset($data['refund_amount']) ? $data['refund_amount'] : null;
        $this->container['fee_refund'] = isset($data['fee_refund']) ? $data['fee_refund'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['expected_refund_settlement_date'] = isset($data['expected_refund_settlement_date']) ? $data['expected_refund_settlement_date'] : null;
        $this->container['refund_date'] = isset($data['refund_date']) ? $data['refund_date'] : null;
        $this->container['refund_entry_date'] = isset($data['refund_entry_date']) ? $data['refund_entry_date'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['source_payment'] = isset($data['source_payment']) ? $data['source_payment'] : null;
        $this->container['payment_network_response'] = isset($data['payment_network_response']) ? $data['payment_network_response'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['refund_reference']) && (mb_strlen($this->container['refund_reference']) > 50)) {
            $invalidProperties[] = "invalid value for 'refund_reference', the character length must be smaller than or equal to 50.";
        }

        if (!is_null($this->container['refund_reference']) && (mb_strlen($this->container['refund_reference']) < 0)) {
            $invalidProperties[] = "invalid value for 'refund_reference', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['refund_reference']) && !preg_match("/[0-9a-zA-Z._-]{0,50}/", $this->container['refund_reference'])) {
            $invalidProperties[] = "invalid value for 'refund_reference', must be conform to the pattern /[0-9a-zA-Z._-]{0,50}/.";
        }

        if (!is_null($this->container['id']) && (mb_strlen($this->container['id']) > 20)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be smaller than or equal to 20.";
        }

        if (!is_null($this->container['id']) && (mb_strlen($this->container['id']) < 0)) {
            $invalidProperties[] = "invalid value for 'id', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['id']) && !preg_match("/[0-9]{0,20}/", $this->container['id'])) {
            $invalidProperties[] = "invalid value for 'id', must be conform to the pattern /[0-9]{0,20}/.";
        }

        $allowedValues = $this->getRefundTypeAllowableValues();
        if (!is_null($this->container['refund_type']) && !in_array($this->container['refund_type'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'refund_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['refund_amount']) && (mb_strlen($this->container['refund_amount']) > 17)) {
            $invalidProperties[] = "invalid value for 'refund_amount', the character length must be smaller than or equal to 17.";
        }

        if (!is_null($this->container['refund_amount']) && (mb_strlen($this->container['refund_amount']) < 1)) {
            $invalidProperties[] = "invalid value for 'refund_amount', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['refund_amount']) && !preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['refund_amount'])) {
            $invalidProperties[] = "invalid value for 'refund_amount', must be conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.";
        }

        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($this->container['status']) && !in_array($this->container['status'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'status', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['confirmation_number']) && (mb_strlen($this->container['confirmation_number']) > 30)) {
            $invalidProperties[] = "invalid value for 'confirmation_number', the character length must be smaller than or equal to 30.";
        }

        if (!is_null($this->container['confirmation_number']) && (mb_strlen($this->container['confirmation_number']) < 0)) {
            $invalidProperties[] = "invalid value for 'confirmation_number', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['confirmation_number']) && !preg_match("/[a-zA-Z0-9]+/", $this->container['confirmation_number'])) {
            $invalidProperties[] = "invalid value for 'confirmation_number', must be conform to the pattern /[a-zA-Z0-9]+/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets refund_reference
     *
     * @return string
     */
    public function getRefundReference()
    {
        return $this->container['refund_reference'];
    }

    /**
     * Sets refund_reference
     *
     * @param string $refund_reference The unique identifier in the client system for the refund.
     *
     * @return $this
     */
    public function setRefundReference($refund_reference)
    {
        if (!is_null($refund_reference) && (mb_strlen($refund_reference) > 50)) {
            throw new \InvalidArgumentException('invalid length for $refund_reference when calling RefundResponse., must be smaller than or equal to 50.');
        }
        if (!is_null($refund_reference) && (mb_strlen($refund_reference) < 0)) {
            throw new \InvalidArgumentException('invalid length for $refund_reference when calling RefundResponse., must be bigger than or equal to 0.');
        }
        if (!is_null($refund_reference) && (!preg_match("/[0-9a-zA-Z._-]{0,50}/", $refund_reference))) {
            throw new \InvalidArgumentException("invalid value for $refund_reference when calling RefundResponse., must conform to the pattern /[0-9a-zA-Z._-]{0,50}/.");
        }

        $this->container['refund_reference'] = $refund_reference;

        return $this;
    }

    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by Orbipay to the refund.
     *
     * @return $this
     */
    public function setId($id)
    {
        if (!is_null($id) && (mb_strlen($id) > 20)) {
            throw new \InvalidArgumentException('invalid length for $id when calling RefundResponse., must be smaller than or equal to 20.');
        }
        if (!is_null($id) && (mb_strlen($id) < 0)) {
            throw new \InvalidArgumentException('invalid length for $id when calling RefundResponse., must be bigger than or equal to 0.');
        }
        if (!is_null($id) && (!preg_match("/[0-9]{0,20}/", $id))) {
            throw new \InvalidArgumentException("invalid value for $id when calling RefundResponse., must conform to the pattern /[0-9]{0,20}/.");
        }

        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of refund.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets refund_type
     *
     * @return string
     */
    public function getRefundType()
    {
        return $this->container['refund_type'];
    }

    /**
     * Sets refund_type
     *
     * @param string $refund_type The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.
     *
     * @return $this
     */
    public function setRefundType($refund_type)
    {
        $allowedValues = $this->getRefundTypeAllowableValues();
        if (!is_null($refund_type) && !in_array($refund_type, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'refund_type', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['refund_type'] = $refund_type;

        return $this;
    }

    /**
     * Gets refund_amount
     *
     * @return string
     */
    public function getRefundAmount()
    {
        return $this->container['refund_amount'];
    }

    /**
     * Sets refund_amount
     *
     * @param string $refund_amount The refund amount upto 2 decimal places.
     *
     * @return $this
     */
    public function setRefundAmount($refund_amount)
    {
        if (!is_null($refund_amount) && (mb_strlen($refund_amount) > 17)) {
            throw new \InvalidArgumentException('invalid length for $refund_amount when calling RefundResponse., must be smaller than or equal to 17.');
        }
        if (!is_null($refund_amount) && (mb_strlen($refund_amount) < 1)) {
            throw new \InvalidArgumentException('invalid length for $refund_amount when calling RefundResponse., must be bigger than or equal to 1.');
        }
        if (!is_null($refund_amount) && (!preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $refund_amount))) {
            throw new \InvalidArgumentException("invalid value for $refund_amount when calling RefundResponse., must conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.");
        }

        $this->container['refund_amount'] = $refund_amount;

        return $this;
    }

    /**
     * Gets fee_refund
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRefund
     */
    public function getFeeRefund()
    {
        return $this->container['fee_refund'];
    }

    /**
     * Sets fee_refund
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRefund $fee_refund fee_refund
     *
     * @return $this
     */
    public function setFeeRefund($fee_refund)
    {
        $this->container['fee_refund'] = $fee_refund;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the refund.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $allowedValues = $this->getStatusAllowableValues();
        if (!is_null($status) && !in_array($status, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'status', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the refund.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        if (!is_null($confirmation_number) && (mb_strlen($confirmation_number) > 30)) {
            throw new \InvalidArgumentException('invalid length for $confirmation_number when calling RefundResponse., must be smaller than or equal to 30.');
        }
        if (!is_null($confirmation_number) && (mb_strlen($confirmation_number) < 0)) {
            throw new \InvalidArgumentException('invalid length for $confirmation_number when calling RefundResponse., must be bigger than or equal to 0.');
        }
        if (!is_null($confirmation_number) && (!preg_match("/[a-zA-Z0-9]+/", $confirmation_number))) {
            throw new \InvalidArgumentException("invalid value for $confirmation_number when calling RefundResponse., must conform to the pattern /[a-zA-Z0-9]+/.");
        }

        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
         * Gets refund_date
         *
         * @return \DateTime
         */
        public function getRefundDate()
        {
            return $this->container['refund_date'];
        }

        /**
         * Sets refund_date
         *
         * @param \DateTime $refund_date The date on which the refund is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
         *
         * @return $this
         */
        public function setRefundDate($refund_date)
        {
            $this->container['refund_date'] = $refund_date;

            return $this;
        }

        /**
         * Gets refund_entry_date
         *
         * @return \DateTime
         */
        public function getRefundEntryDate()
        {
            return $this->container['refund_entry_date'];
        }

        /**
         * Sets refund_entry_date
         *
         * @param \DateTime $refund_entry_date The date on which the refund captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
         *
         * @return $this
         */
        public function setRefundEntryDate($refund_entry_date)
        {
            $this->container['refund_entry_date'] = $refund_entry_date;

            return $this;
        }


    /**
     * Gets expected_refund_settlement_date
     *
     * @return string
     */
    public function getExpectedRefundSettlementDate()
    {
        return $this->container['expected_refund_settlement_date'];
    }

    /**
     * Sets expected_refund_settlement_date
     *
     * @param string $expected_refund_settlement_date The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD
     *
     * @return $this
     */
    public function setExpectedRefundSettlementDate($expected_refund_settlement_date)
    {
        $this->container['expected_refund_settlement_date'] = $expected_refund_settlement_date;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param  $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets source_payment
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\SourcePayment
     */
    public function getSourcePayment()
    {
        return $this->container['source_payment'];
    }

    /**
     * Sets source_payment
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\SourcePayment $source_payment source_payment
     *
     * @return $this
     */
    public function setSourcePayment($source_payment)
    {
        $this->container['source_payment'] = $source_payment;

        return $this;
    }

    /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse
     */
    public function getPaymentNetworkResponse()
    {
        return $this->container['payment_network_response'];
    }

    /**
     * Sets payment_network_response
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\PaymentNetworkResponse $payment_network_response payment_network_response
     *
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->container['payment_network_response'] = $payment_network_response;

        return $this;
    }

    /**
     * Gets auditInfo
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets auditInfo
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AuditInfo $auditInfo AuditInfo
     *
     * @return $this
     */
    public function setAuditInfo($auditInfo)
    {
        $this->container['audit_info'] = $auditInfo;

        return $this;
    }


    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


