<?php
/**
 * UpdateCustomerRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * UpdateCustomerRequest Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class UpdateCustomerRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'UpdateCustomerRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'first_name' => 'string',
        'last_name' => 'string',
        'middle_name' => 'string',
        'gender' => 'string',
        'date_of_birth' => 'string',
        'ssn' => 'string',
        'locale' => 'string',
        'email' => 'string',
        'registered_email' => 'string',
        'home_phone' => 'string',
        'work_phone' => 'string',
        'mobile_phone' => 'string',
        'address' => '\Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO',
        'status' => 'string',
        'customer_accounts' => '\Orbipay\PaymentsApi\Client\Swagger\Model\UpdateCustomerAccountRequest[]',
        'comments' => 'string',
        'custom_fields' => 'object'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'first_name' => null,
        'last_name' => null,
        'middle_name' => null,
        'gender' => null,
        'date_of_birth' => null,
        'ssn' => null,
        'locale' => null,
        'email' => null,
        'registered_email' => null,
        'home_phone' => null,
        'work_phone' => null,
        'mobile_phone' => null,
        'address' => null,
        'status' => null,
        'customer_accounts' => null,
        'comments' => null,
        'custom_fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'first_name' => 'first_name',
        'last_name' => 'last_name',
        'middle_name' => 'middle_name',
        'gender' => 'gender',
        'date_of_birth' => 'date_of_birth',
        'ssn' => 'ssn',
        'locale' => 'locale',
        'email' => 'email',
        'registered_email' => 'registered_email',
        'home_phone' => 'home_phone',
        'work_phone' => 'work_phone',
        'mobile_phone' => 'mobile_phone',
        'address' => 'address',
        'status' => 'status',
        'customer_accounts' => 'customer_accounts',
        'comments' => 'comments',
        'custom_fields' => 'custom_fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'first_name' => 'setFirstName',
        'last_name' => 'setLastName',
        'middle_name' => 'setMiddleName',
        'gender' => 'setGender',
        'date_of_birth' => 'setDateOfBirth',
        'ssn' => 'setSsn',
        'locale' => 'setLocale',
        'email' => 'setEmail',
        'registered_email' => 'setRegisteredEmail',
        'home_phone' => 'setHomePhone',
        'work_phone' => 'setWorkPhone',
        'mobile_phone' => 'setMobilePhone',
        'address' => 'setAddress',
        'status' => 'setStatus',
        'customer_accounts' => 'setCustomerAccounts',
        'comments' => 'setComments',
        'custom_fields' => 'setCustomFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'first_name' => 'getFirstName',
        'last_name' => 'getLastName',
        'middle_name' => 'getMiddleName',
        'gender' => 'getGender',
        'date_of_birth' => 'getDateOfBirth',
        'ssn' => 'getSsn',
        'locale' => 'getLocale',
        'email' => 'getEmail',
        'registered_email' => 'getRegisteredEmail',
        'home_phone' => 'getHomePhone',
        'work_phone' => 'getWorkPhone',
        'mobile_phone' => 'getMobilePhone',
        'address' => 'getAddress',
        'status' => 'getStatus',
        'customer_accounts' => 'getCustomerAccounts',
        'comments' => 'getComments',
        'custom_fields' => 'getCustomFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const GENDER_MALE = 'male';
    const GENDER_FEMALE = 'female';
    const STATUS_ACTIVE = 'active';
    const STATUS_DISABLED = 'disabled';
    const STATUS_VOLUNTARY_CANCELLATION = 'voluntary_cancellation';
    const STATUS_REVOKED = 'revoked';
    const STATUS_SUSPENDED = 'suspended';
    const STATUS_INACTIVE = 'inactive';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getGenderAllowableValues()
    {
        return [
            self::GENDER_MALE,
            self::GENDER_FEMALE,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_ACTIVE,
            self::STATUS_DISABLED,
            self::STATUS_VOLUNTARY_CANCELLATION,
            self::STATUS_REVOKED,
            self::STATUS_SUSPENDED,
            self::STATUS_INACTIVE,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['first_name'] = isset($data['first_name']) ? $data['first_name'] : null;
        $this->container['last_name'] = isset($data['last_name']) ? $data['last_name'] : null;
        $this->container['middle_name'] = isset($data['middle_name']) ? $data['middle_name'] : null;
        $this->container['gender'] = isset($data['gender']) ? $data['gender'] : null;
        $this->container['date_of_birth'] = isset($data['date_of_birth']) ? $data['date_of_birth'] : null;
        $this->container['ssn'] = isset($data['ssn']) ? $data['ssn'] : null;
        $this->container['locale'] = isset($data['locale']) ? $data['locale'] : null;
        $this->container['email'] = isset($data['email']) ? $data['email'] : null;
        $this->container['registered_email'] = isset($data['registered_email']) ? $data['registered_email'] : null;
        $this->container['home_phone'] = isset($data['home_phone']) ? $data['home_phone'] : null;
        $this->container['work_phone'] = isset($data['work_phone']) ? $data['work_phone'] : null;
        $this->container['mobile_phone'] = isset($data['mobile_phone']) ? $data['mobile_phone'] : null;
        $this->container['address'] = isset($data['address']) ? $data['address'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['customer_accounts'] = isset($data['customer_accounts']) ? $data['customer_accounts'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['first_name']) && (strlen($this->container['first_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'first_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['first_name']) && (strlen($this->container['first_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'first_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['first_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['first_name'])) {
            $invalidProperties[] = "invalid value for 'first_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['last_name']) && (strlen($this->container['last_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'last_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['last_name']) && (strlen($this->container['last_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'last_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['last_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['last_name'])) {
            $invalidProperties[] = "invalid value for 'last_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['middle_name']) && (strlen($this->container['middle_name']) > 60)) {
            $invalidProperties[] = "invalid value for 'middle_name', the character length must be smaller than or equal to 60.";
        }

        if (!is_null($this->container['middle_name']) && (strlen($this->container['middle_name']) < 0)) {
            $invalidProperties[] = "invalid value for 'middle_name', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['middle_name']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['middle_name'])) {
            $invalidProperties[] = "invalid value for 'middle_name', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        $allowedValues = $this->getGenderAllowableValues();
        if (!in_array($this->container['gender'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'gender', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['date_of_birth']) && (strlen($this->container['date_of_birth']) > 10)) {
            $invalidProperties[] = "invalid value for 'date_of_birth', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['date_of_birth']) && (strlen($this->container['date_of_birth']) < 10)) {
            $invalidProperties[] = "invalid value for 'date_of_birth', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['ssn']) && (strlen($this->container['ssn']) > 9)) {
            $invalidProperties[] = "invalid value for 'ssn', the character length must be smaller than or equal to 9.";
        }

        if (!is_null($this->container['ssn']) && (strlen($this->container['ssn']) < 9)) {
            $invalidProperties[] = "invalid value for 'ssn', the character length must be bigger than or equal to 9.";
        }

        if (!is_null($this->container['ssn']) && !preg_match("/[0-9]{9}/", $this->container['ssn'])) {
            $invalidProperties[] = "invalid value for 'ssn', must be conform to the pattern /[0-9]{9}/.";
        }

        if (!is_null($this->container['locale']) && (strlen($this->container['locale']) > 5)) {
            $invalidProperties[] = "invalid value for 'locale', the character length must be smaller than or equal to 5.";
        }

        if (!is_null($this->container['locale']) && (strlen($this->container['locale']) < 5)) {
            $invalidProperties[] = "invalid value for 'locale', the character length must be bigger than or equal to 5.";
        }

        if (!is_null($this->container['locale']) && !preg_match("/^[a-z]{2}_[A-Z]{2}$/", $this->container['locale'])) {
            $invalidProperties[] = "invalid value for 'locale', must be conform to the pattern /^[a-z]{2}_[A-Z]{2}$/.";
        }

        if (!is_null($this->container['email']) && (strlen($this->container['email']) > 100)) {
            $invalidProperties[] = "invalid value for 'email', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['email']) && (strlen($this->container['email']) < 0)) {
            $invalidProperties[] = "invalid value for 'email', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['email']) && !preg_match("/[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/", $this->container['email'])) {
            $invalidProperties[] = "invalid value for 'email', must be conform to the pattern /[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/.";
        }

        if (!is_null($this->container['home_phone']) && (strlen($this->container['home_phone']) > 10)) {
            $invalidProperties[] = "invalid value for 'home_phone', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['home_phone']) && (strlen($this->container['home_phone']) < 10)) {
            $invalidProperties[] = "invalid value for 'home_phone', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['home_phone']) && !preg_match("/[0-9]{10}/", $this->container['home_phone'])) {
            $invalidProperties[] = "invalid value for 'home_phone', must be conform to the pattern /[0-9]{10}/.";
        }

        if (!is_null($this->container['work_phone']) && (strlen($this->container['work_phone']) > 10)) {
            $invalidProperties[] = "invalid value for 'work_phone', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['work_phone']) && (strlen($this->container['work_phone']) < 10)) {
            $invalidProperties[] = "invalid value for 'work_phone', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['work_phone']) && !preg_match("/[0-9]{10}/", $this->container['work_phone'])) {
            $invalidProperties[] = "invalid value for 'work_phone', must be conform to the pattern /[0-9]{10}/.";
        }

        if (!is_null($this->container['mobile_phone']) && (strlen($this->container['mobile_phone']) > 10)) {
            $invalidProperties[] = "invalid value for 'mobile_phone', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['mobile_phone']) && (strlen($this->container['mobile_phone']) < 10)) {
            $invalidProperties[] = "invalid value for 'mobile_phone', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['mobile_phone']) && !preg_match("/[0-9]{10}/", $this->container['mobile_phone'])) {
            $invalidProperties[] = "invalid value for 'mobile_phone', must be conform to the pattern /[0-9]{10}/.";
        }

        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'status', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) > 100)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) < 0)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['comments']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            $invalidProperties[] = "invalid value for 'comments', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['first_name']) > 60) {
            return false;
        }
        if (strlen($this->container['first_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['first_name'])) {
            return false;
        }
        if (strlen($this->container['last_name']) > 60) {
            return false;
        }
        if (strlen($this->container['last_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['last_name'])) {
            return false;
        }
        if (strlen($this->container['middle_name']) > 60) {
            return false;
        }
        if (strlen($this->container['middle_name']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['middle_name'])) {
            return false;
        }
        $allowedValues = $this->getGenderAllowableValues();
        if (!in_array($this->container['gender'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['date_of_birth']) > 10) {
            return false;
        }
        if (strlen($this->container['date_of_birth']) < 10) {
            return false;
        }
        if (strlen($this->container['ssn']) > 9) {
            return false;
        }
        if (strlen($this->container['ssn']) < 9) {
            return false;
        }
        if (!preg_match("/[0-9]{9}/", $this->container['ssn'])) {
            return false;
        }
        if (strlen($this->container['locale']) > 5) {
            return false;
        }
        if (strlen($this->container['locale']) < 5) {
            return false;
        }
        if (!preg_match("/^[a-z]{2}_[A-Z]{2}$/", $this->container['locale'])) {
            return false;
        }
        if (strlen($this->container['email']) > 100) {
            return false;
        }
        if (strlen($this->container['email']) < 0) {
            return false;
        }
        if (!preg_match("/[a-zA-Z0-9!#$%&'*+-\/=?^._`{|}~]+@[a-zA-Z0-9_.-]+\\.[a-zA-Z0-9._]+/", $this->container['email'])) {
            return false;
        }
        if (strlen($this->container['home_phone']) > 10) {
            return false;
        }
        if (strlen($this->container['home_phone']) < 10) {
            return false;
        }
        if (!preg_match("/[0-9]{10}/", $this->container['home_phone'])) {
            return false;
        }
        if (strlen($this->container['work_phone']) > 10) {
            return false;
        }
        if (strlen($this->container['work_phone']) < 10) {
            return false;
        }
        if (!preg_match("/[0-9]{10}/", $this->container['work_phone'])) {
            return false;
        }
        if (strlen($this->container['mobile_phone']) > 10) {
            return false;
        }
        if (strlen($this->container['mobile_phone']) < 10) {
            return false;
        }
        if (!preg_match("/[0-9]{10}/", $this->container['mobile_phone'])) {
            return false;
        }
        $allowedValues = $this->getStatusAllowableValues();
        if (!in_array($this->container['status'], $allowedValues)) {
            return false;
        }
        if (strlen($this->container['comments']) > 100) {
            return false;
        }
        if (strlen($this->container['comments']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            return false;
        }
        return true;
    }


    /**
     * Gets first_name
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->container['first_name'];
    }

    /**
     * Sets first_name
     *
     * @param string $first_name The first name of the customer.
     *
     * @return $this
     */
    public function setFirstName($first_name)
    {
        $this->container['first_name'] = $first_name;

        return $this;
    }

    /**
     * Gets last_name
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->container['last_name'];
    }

    /**
     * Sets last_name
     *
     * @param string $last_name The last name of the customer.
     *
     * @return $this
     */
    public function setLastName($last_name)
    {
        $this->container['last_name'] = $last_name;

        return $this;
    }

    /**
     * Gets middle_name
     *
     * @return string
     */
    public function getMiddleName()
    {
        return $this->container['middle_name'];
    }

    /**
     * Sets middle_name
     *
     * @param string $middle_name The middle name of the customer.
     *
     * @return $this
     */
    public function setMiddleName($middle_name)
    {
        $this->container['middle_name'] = $middle_name;

        return $this;
    }

    /**
     * Gets gender
     *
     * @return string
     */
    public function getGender()
    {
        return $this->container['gender'];
    }

    /**
     * Sets gender
     *
     * @param string $gender The gender of the customer.
     *
     * @return $this
     */
    public function setGender($gender)
    {
        $this->container['gender'] = $gender;

        return $this;
    }

    /**
     * Gets date_of_birth
     *
     * @return string
     */
    public function getDateOfBirth()
    {
        return $this->container['date_of_birth'];
    }

    /**
     * Sets date_of_birth
     *
     * @param string $date_of_birth The date of birth of the customer. It should be in the full-date format as per ISO8601, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setDateOfBirth($date_of_birth)
    {
        $this->container['date_of_birth'] = $date_of_birth;

        return $this;
    }

    /**
     * Gets ssn
     *
     * @return string
     */
    public function getSsn()
    {
        return $this->container['ssn'];
    }

    /**
     * Sets ssn
     *
     * @param string $ssn The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.
     *
     * @return $this
     */
    public function setSsn($ssn)
    {
        $this->container['ssn'] = $ssn;

        return $this;
    }

    /**
     * Gets locale
     *
     * @return string
     */
    public function getLocale()
    {
        return $this->container['locale'];
    }

    /**
     * Sets locale
     *
     * @param string $locale The language in which the payee wants the alerts and notifications from Orbipay. This is to be specified in the format,<br><i>< <b>ISO-639-1 language code</b>  >_< <b>ISO ALPHA-2 Country Code</b> ></i>.<br> For e.g., <b>en_US</b> indicates the language preference as US English, which is also the default value.
     *
     * @return $this
     */
    public function setLocale($locale)
    {
        $this->container['locale'] = $locale;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string $email The email address of the customer.
     *
     * @return $this
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets registered_email
     *
     * @return string
     */
    public function getRegisteredEmail()
    {
        return $this->container['registered_email'];
    }

    /**
     * Sets registered_email
     *
     * @param string $registered_email The email address of the customer.
     *
     * @return $this
     */
    public function setRegisteredEmail($registeredEmail)
    {
        $this->container['registered_email'] = $registeredEmail;

        return $this;
    }

    /**
     * Gets home_phone
     *
     * @return string
     */
    public function getHomePhone()
    {
        return $this->container['home_phone'];
    }

    /**
     * Sets home_phone
     *
     * @param string $home_phone The home phone number of the customer.
     *
     * @return $this
     */
    public function setHomePhone($home_phone)
    {
        $this->container['home_phone'] = $home_phone;

        return $this;
    }

    /**
     * Gets work_phone
     *
     * @return string
     */
    public function getWorkPhone()
    {
        return $this->container['work_phone'];
    }

    /**
     * Sets work_phone
     *
     * @param string $work_phone The work phone number of the customer.
     *
     * @return $this
     */
    public function setWorkPhone($work_phone)
    {
        $this->container['work_phone'] = $work_phone;

        return $this;
    }

    /**
     * Gets mobile_phone
     *
     * @return string
     */
    public function getMobilePhone()
    {
        return $this->container['mobile_phone'];
    }

    /**
     * Sets mobile_phone
     *
     * @param string $mobile_phone The mobile phone number of the customer.
     *
     * @return $this
     */
    public function setMobilePhone($mobile_phone)
    {
        $this->container['mobile_phone'] = $mobile_phone;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\AddressVO $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the customer in Orbipay.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets customer_accounts
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\UpdateCustomerAccountRequest[]
     */
    public function getCustomerAccounts()
    {
        return $this->container['customer_accounts'];
    }

    /**
     * Sets customer_accounts
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\UpdateCustomerAccountRequest[] $customer_accounts customer_accounts
     *
     * @return $this
     */
    public function setCustomerAccounts($customer_accounts)
    {
        $this->container['customer_accounts'] = $customer_accounts;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments comments
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets custom_fields
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     * @param object $custom_fields
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {


        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


