<?php
/**
 * UpdatePaymentRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.3.1
 */

/**
 * NOTE: This class is auto generated by the Swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Swagger\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\Swagger\ObjectSerializer;

/**
 * UpdatePaymentRequest Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class UpdatePaymentRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
     * The original name of the model.
     *
     * @var string
     */
    protected static $swaggerModelName = 'UpdatePaymentRequest';

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @var string[]
     */
    protected static $swaggerTypes = [
        'comments' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'payment_date' => 'string',
        'payment_request_date' => 'string',
        'payment_amount_type' => 'string',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest',
        'custom_fields' => 'object'
    ];

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @var string[]
     */
    protected static $swaggerFormats = [
        'comments' => null,
        'fee' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'payment_date' => null,
        'payment_request_date' => null,
        'payment_amount_type' => null,
        'funding_account' => null,
        'custom_fields' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'comments' => 'comments',
        'fee' => 'fee',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'payment_date' => 'payment_date',
        'payment_request_date' => 'payment_request_date',
        'payment_amount_type' => 'payment_amount_type',
        'funding_account' => 'funding_account',
        'custom_fields' => 'custom_fields'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'comments' => 'setComments',
        'fee' => 'setFee',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'payment_date' => 'setPaymentDate',
        'payment_request_date' => 'setPaymentRequestDate',
        'payment_amount_type' => 'setPaymentAmountType',
        'funding_account' => 'setFundingAccount',
        'custom_fields' => 'setCustomFields'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'comments' => 'getComments',
        'fee' => 'getFee',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'payment_date' => 'getPaymentDate',
        'payment_request_date' => 'getPaymentRequestDate',
        'payment_amount_type' => 'getPaymentAmountType',
        'funding_account' => 'getFundingAccount',
        'custom_fields' => 'getCustomFields'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT = 'discounted_amount';
    const PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT = 'penalty_amount';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';


    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['payment_date'] = isset($data['payment_date']) ? $data['payment_date'] : null;
        $this->container['payment_request_date'] = isset($data['payment_request_date']) ? $data['payment_request_date'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) > 100)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be smaller than or equal to 100.";
        }

        if (!is_null($this->container['comments']) && (strlen($this->container['comments']) < 0)) {
            $invalidProperties[] = "invalid value for 'comments', the character length must be bigger than or equal to 0.";
        }

        if (!is_null($this->container['comments']) && !preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            $invalidProperties[] = "invalid value for 'comments', must be conform to the pattern /[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/.";
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) > 17)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be smaller than or equal to 17.";
        }

        if (!is_null($this->container['amount']) && (strlen($this->container['amount']) < 1)) {
            $invalidProperties[] = "invalid value for 'amount', the character length must be bigger than or equal to 1.";
        }

        if (!is_null($this->container['amount']) && !preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            $invalidProperties[] = "invalid value for 'amount', must be conform to the pattern /^[0-9]{1,14}(\\.[0-9][0-9]?)?$/.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) > 4)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be smaller than or equal to 4.";
        }

        if (!is_null($this->container['card_cvv_number']) && (strlen($this->container['card_cvv_number']) < 3)) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', the character length must be bigger than or equal to 3.";
        }

        if (!is_null($this->container['card_cvv_number']) && !preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            $invalidProperties[] = "invalid value for 'card_cvv_number', must be conform to the pattern /[0-9]{3,4}/.";
        }

        if (!is_null($this->container['payment_date']) && (strlen($this->container['payment_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_date']) && (strlen($this->container['payment_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_date', the character length must be bigger than or equal to 10.";
        }

        if (!is_null($this->container['payment_request_date']) && (strlen($this->container['payment_request_date']) > 10)) {
            $invalidProperties[] = "invalid value for 'payment_request_date', the character length must be smaller than or equal to 10.";
        }

        if (!is_null($this->container['payment_request_date']) && (strlen($this->container['payment_request_date']) < 10)) {
            $invalidProperties[] = "invalid value for 'payment_request_date', the character length must be bigger than or equal to 10.";
        }

        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'payment_amount_type', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if (strlen($this->container['comments']) > 100) {
            return false;
        }
        if (strlen($this->container['comments']) < 0) {
            return false;
        }
        if (!preg_match("/[0-9a-zA-Z #,.'&\/\\-@!$%*()_+={}|:;`\\[\\]\\^\\~\\\\\"]+/", $this->container['comments'])) {
            return false;
        }
        if (strlen($this->container['amount']) > 17) {
            return false;
        }
        if (strlen($this->container['amount']) < 1) {
            return false;
        }
        if (!preg_match("/^[0-9]{1,14}(\\.[0-9][0-9]?)?$/", $this->container['amount'])) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) > 4) {
            return false;
        }
        if (strlen($this->container['card_cvv_number']) < 3) {
            return false;
        }
        if (!preg_match("/[0-9]{3,4}/", $this->container['card_cvv_number'])) {
            return false;
        }
        if (strlen($this->container['payment_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_date']) < 10) {
            return false;
        }
        if (strlen($this->container['payment_request_date']) > 10) {
            return false;
        }
        if (strlen($this->container['payment_request_date']) < 10) {
            return false;
        }
        $allowedValues = $this->getPaymentAmountTypeAllowableValues();
        if (!in_array($this->container['payment_amount_type'], $allowedValues)) {
            return false;
        }
        return true;
    }


    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments comments
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FeeRequest $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets payment_date
     *
     * @return string
     */
    public function getPaymentDate()
    {
        return $this->container['payment_date'];
    }

    /**
     * Sets payment_date
     *
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->container['payment_date'] = $payment_date;

        return $this;
    }

    /**
     * Gets payment_request_date
     *
     * @return string
     */
    public function getPaymentRequestDate()
    {
        return $this->container['payment_request_date'];
    }

    /**
     * Sets payment_request_date
     *
     * @param string $payment_request_date The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.  This is applicable only if the client has opted for it.
     *
     * @return $this
     */
    public function setPaymentRequestDate($payment_request_date)
    {
        $this->container['payment_request_date'] = $payment_request_date;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Swagger\Model\FundingAccountMinimalRequest $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets custom_fields
     * @return object
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     * @param object $custom_fields
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed $value Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {


        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


